//**********************************************************************
//    Transducer Block	1 (Main Process Value)	
//**********************************************************************
/*#tb
BLOCK function_block_1
{
	TYPE FUNCTION;
	NUMBER 1;
}
*/

//----------------------------------------------------------------------
//  BLOCK_OBJECT: 12 x analog_input1_blk...
//----------------------------------------------------------------------

analog_input1_blk_reserve		LIKE VARIABLE	phys_blk_reserve
{											
}											

analog_input1_blk_object		LIKE VARIABLE	phys_blk_object
{
	REDEFINE TYPE ENUMERATED (1)
	{
		{	1,	[blk_block_object_FUNCTION]	}
	}
}		
									
analog_input1_blk_parent_class		LIKE VARIABLE	phys_blk_parent_class
{	
}	
										
analog_input1_blk_class		LIKE VARIABLE	phys_blk_class
{											
}	
										
analog_input1_blk_dd_reference		LIKE VARIABLE	phys_blk_dd_reference
{											
}	
										
analog_input1_blk_dd_rev		LIKE VARIABLE	phys_blk_dd_rev
{											
}	
										
analog_input1_blk_profile		LIKE VARIABLE	phys_blk_profile
{											
}	
										
analog_input1_blk_profile_rev		LIKE VARIABLE	phys_blk_profile_rev
{											
}	
										
analog_input1_blk_execution_time		LIKE VARIABLE	phys_blk_execution_time
{											
}		
									
analog_input1_blk_num_parameters		LIKE VARIABLE	phys_blk_num_parameters
{											
}		
									
analog_input1_blk_index_view_1		LIKE VARIABLE	phys_blk_index_view_1
{											
}		
									
analog_input1_blk_num_view_lists		LIKE VARIABLE	phys_blk_num_view_lists
{											
}											

analog_input1_st_rev		LIKE VARIABLE	phys_st_rev
{											
}											

analog_input1_tag_desc		LIKE VARIABLE	phys_tag_desc
{											
}											

analog_input1_strategy		LIKE VARIABLE	phys_strategy
{											
}											

analog_input1_alert_key		LIKE VARIABLE	phys_alert_key
{											
}											

VARIABLE analog_input1_target_mode
{
	LABEL		[target_mode];		
	HELP		[target_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{BLOCK_MODE_AUTO			,	[mode_AUTO]				},
		{BLOCK_MODE_MAN				,	[mode_MAN]				},
		{BLOCK_MODE_OUT_OF_SERVICE	,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_actual_mode
{
	LABEL		[actual_mode];
	HELP		[actual_mode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{BLOCK_MODE_AUTO			,	[mode_AUTO]		},
		{BLOCK_MODE_MAN				,	[mode_MAN]		},
		{BLOCK_MODE_OUT_OF_SERVICE	,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE analog_input1_permitted_mode
{
	LABEL		[permitted_mode];
	HELP		[permitted_mode_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{BLOCK_MODE_AUTO			,	[mode_AUTO]		},
		{BLOCK_MODE_MAN				,	[mode_MAN]		},
		{BLOCK_MODE_OUT_OF_SERVICE	,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE analog_input1_normal_mode
{
	LABEL		[normal_mode];
	HELP		[normal_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	BLOCK_MODE_AUTO;
		{BLOCK_MODE_AUTO			,	[mode_AUTO]		},
		{BLOCK_MODE_MAN				,	[mode_MAN]		},
		{BLOCK_MODE_OUT_OF_SERVICE	,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

analog_input1_current_state_alarm_sum		LIKE VARIABLE	phys_current_state_alarm_sum
{	
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
//#tb		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]	},
		{	0x0400,	[limit_state_HI]	},
		{	0x0800,	[limit_state_LO_LO]	},
		{	0x1000,	[limit_state_LO]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
#ifdef _PDM_
	REDEFINE STYLE    "MULTILINE 20 5"; 
#endif
}											

analog_input1_unacknowledged_state_alarm_sum		LIKE VARIABLE	phys_unacknowledged_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
//#tb		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]	},
		{	0x0400,	[limit_state_HI]	},
		{	0x0800,	[limit_state_LO_LO]	},
		{	0x1000,	[limit_state_LO]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

analog_input1_unreported_state_alarm_sum		LIKE VARIABLE	phys_unreported_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
//#tb		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]	},
		{	0x0400,	[limit_state_HI]	},
		{	0x0800,	[limit_state_LO_LO]	},
		{	0x1000,	[limit_state_LO]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

analog_input1_disabled_state_alarm_sum		LIKE VARIABLE	phys_disabled_state_alarm_sum
{
	REDEFINE TYPE		BIT_ENUMERATED (2)
	{
//#tb		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x0200,	[limit_state_HI_HI]	},
		{	0x0400,	[limit_state_HI]	},
		{	0x0800,	[limit_state_LO_LO]	},
		{	0x1000,	[limit_state_LO]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
}

VARIABLE analog_input1_batch_id
{
	LABEL		[func_batch_id];
	HELP		[func_batch_id_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_batch_unit
{
	LABEL		[func_batch_unit];
	HELP		[func_batch_unit_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_batch_operation
{
	LABEL		[func_batch_operation];
	HELP		[func_batch_operation_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_batch_phase
{
	LABEL		[func_batch_phase];
	HELP		[func_batch_phase_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}


//----------------------------------------------------------------------

VARIABLE analog_input1_out_value
{
	//#tb LABEL	[func_out_value];
	LABEL "AI analysis out ch1|de|AI Analyse Ausgang K1";
	HELP	[func_ai_out_value_help];
	CLASS	OUTPUT & DYNAMIC;
	TYPE	FLOAT
	{
		DISPLAY_FORMAT		"4.2f";
	}
	HANDLING
		IF (analog_input1_target_mode == BLOCK_MODE_MAN)
		{
			READ & WRITE;
		}
		ELSE 
		{
			READ;
		}
}

VARIABLE analog_input1_out_status_quality
{
	LABEL		[status_quality];
	HELP		[func_out_status_help];
	CLASS		OUTPUT & DYNAMIC;
	TYPE		ENUMERATED (1)

	{
		DEFAULT_VALUE	0x20;
		IF (analog_input1_target_mode == BLOCK_MODE_MAN)
		{
			STATUS_INPUT_NO_RCAS
		}
		ELSE {
			STATUS_OUTPUT_NO_RCAS
		}
	}
	POST_EDIT_ACTIONS
	{
		IF (analog_input1_target_mode == BLOCK_MODE_MAN)
		{
			//#tb method_set_status_limit_func1_AI
			method_set_status_limit_func1_AI_Out_Quality
		}
	}
	HANDLING
		IF (analog_input1_target_mode == BLOCK_MODE_MAN)
		{
			READ & WRITE;
		}
		ELSE 
		{
			READ;
		}
}

analog_input1_out_status_limit	LIKE VARIABLE	analog_input1_out_status_quality
{
	REDEFINE LABEL		[status_limit];
	REDEFINE TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE 0;
		STATUS_INPUT_LIMIT (analog_input1_out_status_quality)
	}
}

VARIABLE analog_input1_pv_upper_range_value
{
	LABEL	[func_pv_scale_upper_value];
	HELP	[func_pv_scale_upper_value_help];
	CLASS	CONTAINED;
	TYPE	FLOAT;
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_pv_lower_range_value
{
	LABEL	[func_pv_scale_lower_value];
	HELP	[func_pv_scale_lower_value_help];
	CLASS	CONTAINED;
	TYPE	FLOAT;
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_out_upper_range_value
{
	LABEL	[lbl_analog_input1_out_upper_range_value];
	HELP	[func_out_scale_upper_value_help];
	CLASS	CONTAINED;
	TYPE	FLOAT;
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_out_lower_range_value
{
	LABEL	[lbl_analog_input1_out_lower_range_value];
	HELP	[func_out_scale_lower_value_help];
	CLASS	CONTAINED;
	TYPE	FLOAT;
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_out_unit
{
	LABEL	[digital_units];
	HELP	[digital_units_help];
	CLASS	CONTAINED & SERVICE;
	TYPE	ENUMERATED (2)
	{
		DEF_TRANS_UNIT_DEFAULT
		DEF_TRANS_UNIT
	}
	HANDLING	READ & WRITE;
}



VARIABLE analog_input1_out_decimal_point
{
	LABEL	[decimal_point];
	HELP	[decimal_point_help];
	CLASS	CONTAINED;
	TYPE	ENUMERATED (1)
	{
		DEFAULT_VALUE	2;
		{	0,   "0"	},
		{	1,   "1"	},
		{	2,   "2"	},
		{	3,   "3"	},
		{	4,   "4"	},
		{	5,   "5"	},
		{	6,   "6"	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_lin_type
{
	LABEL	[trans_lin_type];
	HELP	[trans_lin_type_help];
	CLASS	CONTAINED;
	TYPE	ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{ 0,	[linear]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_channel
{
	LABEL	[func_channel];
	HELP	[func_channel_help];
	CLASS	CONTAINED;
	TYPE	UNSIGNED_INTEGER(2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_pv_ftime
{
	LABEL	[func_pv_ftime];
	HELP	[func_pv_ftime_help];
	CLASS	CONTAINED;
	TYPE	FLOAT
	{
		DEFAULT_VALUE	0.0;
		MIN_VALUE	0.0;
		MAX_VALUE	100.0;
	}
	CONSTANT_UNIT	[sec];
	HANDLING	READ & WRITE;
}


VARIABLE analog_input1_FSafeType	// Art der Reaktion auf Sensorausfall
{
	LABEL	[func_ao_fsafe_type];
	HELP	[func_ao_fsafe_type_help_PROFILE_3];
	CLASS	CONTAINED;
	TYPE	ENUMERATED (1)
	{
		DEFAULT_VALUE    1;
		{0, "Failsafe value|de|Ausfallsicherungswert"},
		{1, "Last out value|de|Letzer gltiger Wert"},
		{2, "Wrong value|de|Falscher Wert"}
	}
   HANDLING		READ & WRITE;
}

VARIABLE analog_input1_FSafeValue	// Ersatzwert bei Sensorausfall
{
   LABEL	[func_ai_fsafe_value];
   HELP		[func_ai_fsafe_value_help];
   CLASS	CONTAINED;
   TYPE		FLOAT
   {
      DEFAULT_VALUE	0;
   }
   HANDLING	READ & WRITE;
}


VARIABLE analog_input1_hi_hi_lim
{
	LABEL	[limit_hi_hi];
	HELP	[limit_hi_hi_help];
	CLASS	CONTAINED;
	TYPE	FLOAT;
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_hi_lim 
{
	LABEL	[limit_hi];
	HELP	[limit_hi_help];
	CLASS	CONTAINED;
	TYPE	FLOAT;
	HANDLING	READ & WRITE;
}


VARIABLE analog_input1_lo_lim
{
	LABEL	[limit_lo];
	HELP	[limit_lo_help];
	CLASS	CONTAINED;
	TYPE	FLOAT;
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_lo_lo_lim
{
	LABEL	[limit_lo_lo];
	HELP	[limit_lo_lo_help];
	CLASS	CONTAINED;
	TYPE	FLOAT;
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_alarm_hys
{
	LABEL	[limit_hysteresis];
	HELP	[limit_hysteresis_help];
	CLASS	CONTAINED;
	TYPE	FLOAT;
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_hi_hi_alm_unacknowledged
{
	LABEL		[limit_alarm_unacknowledged];
	HELP		[limit_alarm_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE analog_input1_hi_hi_alm_state
{
	LABEL	[limit_state];
	HELP	[limit_hi_hi_state_help];
	CLASS	CONTAINED & DYNAMIC;
	TYPE	ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[limit_state_NO_ALARM]	},
		{	1,	[limit_state_HI_HI]		}
	}
	HANDLING	READ;
}

VARIABLE analog_input1_hi_hi_alm_time_stamp 	
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE analog_input1_hi_hi_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_hi_hi_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE analog_input1_hi_hi_alm_value
{
	LABEL		[limit_alarm_value];
	HELP		[limit_hi_hi_alarm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE analog_input1_hi_alm_unacknowledged
{
	LABEL		[limit_warn_unacknowledged];
	HELP		[limit_warn_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE analog_input1_hi_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_hi_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[limit_state_NO_WARNING]	},
		{	1,	[limit_state_HI]		}
	}
	HANDLING	READ;
}

VARIABLE analog_input1_hi_alm_time_stamp 	
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE analog_input1_hi_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_hi_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE analog_input1_hi_alm_value
{
	LABEL		[limit_warn_value];
	HELP		[limit_hi_warn_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE analog_input1_lo_alm_unacknowledged
{
	LABEL		[limit_warn_unacknowledged];
	HELP		[limit_warn_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE analog_input1_lo_alm_state
{
	LABEL		[limit_state];
	HELP		[limit_lo_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[limit_state_NO_WARNING]	},
		{	1,	[limit_state_LO]		}
	}
	HANDLING	READ;
}

VARIABLE analog_input1_lo_alm_time_stamp 	
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE analog_input1_lo_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_lo_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE analog_input1_lo_alm_value
{
	LABEL		[limit_warn_value];
	HELP		[limit_lo_warn_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE analog_input1_lo_lo_alm_unacknowledged
{
	LABEL		[limit_alarm_unacknowledged];
	HELP		[limit_alarm_unacknowledged_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE analog_input1_lo_lo_alm_state
{
	LABEL	[limit_state];
	HELP	[limit_lo_lo_state_help];
	CLASS	CONTAINED & DYNAMIC;
	TYPE	ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[limit_state_NO_ALARM]		},
		{	1,	[limit_state_LO_LO]		}
	}
	HANDLING	READ;
}

VARIABLE analog_input1_lo_lo_alm_time_stamp
{
	LABEL		[limit_time_stamp];
	HELP		[limit_time_stamp_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		TIME;
	HANDLING	READ;
}

VARIABLE analog_input1_lo_lo_alm_subcode
{
	LABEL		[limit_subcode];
	HELP		[limit_lo_lo_subcode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE analog_input1_lo_lo_alm_value
{
	LABEL		[limit_alarm_value];
	HELP		[limit_lo_lo_alarm_value_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE analog_input1_simulate_value
{
	LABEL	[func_simulate_value];
	HELP	[func_ai_simulate_value_help];
	CLASS	CONTAINED & SERVICE;
	TYPE	FLOAT
	{
		DEFAULT_VALUE	0.0;
	}   
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_simulate_status_quality
{
	LABEL	[status_quality];
	HELP	[func_simulate_status_help];
	CLASS	CONTAINED & SERVICE;
	TYPE	ENUMERATED (1)
	{
		DEFAULT_VALUE	0x20;
		STATUS_INPUT_NO_RCAS
	}
	POST_EDIT_ACTIONS
	{
		method_set_status_limit_func1_AI
	}
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_simulate_status_limit	//LIKE VARIABLE	analog_input1_simulate_status_quality
{
	LABEL	"Limits";
	HELP	[func_simulate_status];
	CLASS	CONTAINED & SERVICE;
	TYPE	ENUMERATED (1)
	{
		DEFAULT_VALUE 0;
		STATUS_OUTPUT_LIMIT
	}
	POST_EDIT_ACTIONS
	{
		//#tb method_set_status_limit_func1_AI
		method_set_status_limit_func1_AI_Sim_Limit
	}
	HANDLING	READ & WRITE;
}

VARIABLE analog_input1_simulation_enabled
{
	LABEL	[func_simulation_enabled];
	HELP	[func_simulation_enabled_help];
	CLASS	CONTAINED;
	TYPE	ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[disabled]	},
		{	1,	[enabled]	}
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------



//---------------------------------------------------------------------
//    Analog Input Block 1 (AI1)	read write - commands
//---------------------------------------------------------------------

COMMAND read_analog_input1_blk
{
	BLOCK function_block_1;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_blk_reserve, analog_input1_blk_object, analog_input1_blk_parent_class, analog_input1_blk_class,
			analog_input1_blk_dd_reference, analog_input1_blk_dd_rev, analog_input1_blk_profile, analog_input1_blk_profile_rev,
			analog_input1_blk_execution_time, analog_input1_blk_num_parameters, analog_input1_blk_index_view_1,
			analog_input1_blk_num_view_lists
		}
	}
}

COMMAND read_analog_input1_st_rev
{
	BLOCK function_block_1;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_st_rev
		}
	}
}

COMMAND read_analog_input1_tag_desc
{
	BLOCK function_block_1;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_tag_desc
		}
	}
}

COMMAND write_analog_input1_tag_desc
{
	BLOCK function_block_1;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_strategy
{
	BLOCK function_block_1;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_strategy
		}
	}
}

COMMAND write_analog_input1_strategy
{
	BLOCK function_block_1;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_alert_key
{
	BLOCK function_block_1;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_alert_key
		}
	}
}

COMMAND write_analog_input1_alert_key
{
	BLOCK function_block_1;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_target_mode
{
	BLOCK function_block_1;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_target_mode
		}
	}
}

COMMAND write_analog_input1_target_mode
{
	BLOCK function_block_1;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
		 	analog_input1_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_mode
{
	BLOCK function_block_1;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 analog_input1_actual_mode, analog_input1_permitted_mode, analog_input1_normal_mode
		}
	}
}

COMMAND read_analog_input1_alarm
{
	BLOCK function_block_1;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_current_state_alarm_sum, analog_input1_unacknowledged_state_alarm_sum,
			analog_input1_unreported_state_alarm_sum, analog_input1_disabled_state_alarm_sum
		}
	}
}

COMMAND read_analog_input1_batch_information
{
	BLOCK function_block_1;
	INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_batch_id, analog_input1_batch_unit,
			analog_input1_batch_operation, analog_input1_batch_phase
		}
	}
}

COMMAND write_analog_input1_batch_information
{
	BLOCK function_block_1;
	INDEX 8;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_batch_id, analog_input1_batch_unit,
			analog_input1_batch_operation, analog_input1_batch_phase
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_out
{
	BLOCK function_block_1;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-33
		{
			analog_input1_out_value,
			analog_input1_out_status_quality	<0xFC>,
			analog_input1_out_status_limit	<0x03>	
		}
	}
}

COMMAND read_analog_input1_pv_scale
{
	BLOCK function_block_1;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// Array 2x float
		{
			analog_input1_pv_upper_range_value, analog_input1_pv_lower_range_value
		}
	}
}

COMMAND write_analog_input1_pv_scale
{
	BLOCK function_block_1;
	INDEX 11;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST		// Array 2x float
		{
			analog_input1_pv_upper_range_value, analog_input1_pv_lower_range_value
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_out_scale
{
	BLOCK function_block_1;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-36
		{
			analog_input1_out_upper_range_value,	
			analog_input1_out_lower_range_value,
			analog_input1_out_unit, 
			analog_input1_out_decimal_point
		}
	}
}

COMMAND write_analog_input1_out_scale
{
	BLOCK function_block_1;
	INDEX 12;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST		// DS-36
		{
			analog_input1_out_upper_range_value, analog_input1_out_lower_range_value,
			analog_input1_out_unit, analog_input1_out_decimal_point
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_lin_type
{
	BLOCK function_block_1;
	INDEX 13;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_lin_type
		}
	}
}

COMMAND write_analog_input1_lin_type
{
	BLOCK function_block_1;
	INDEX 13;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_lin_type
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_channel
{
	BLOCK function_block_1;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_channel
		}
	}
}

COMMAND write_analog_input1_channel
{
	BLOCK function_block_1;
	INDEX 14;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_channel
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_pv_ftime
{
	BLOCK function_block_1;
	INDEX 16;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_pv_ftime
		}
	}
}

COMMAND write_analog_input1_pv_ftime
{
	BLOCK function_block_1;
	INDEX 16;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_pv_ftime
		}
		REPLY
		{
		}
	}
}



//#tb: added
COMMAND read_analog_input1_FSafeType
{
	BLOCK function_block_1;
	INDEX 17;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_FSafeType
		}
	}
}

//#tb: added
COMMAND write_analog_input1_FSafeType
{
	BLOCK function_block_1;
	INDEX 17;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_FSafeType
		}
		REPLY
		{
		}
	}
}

//#tb: added
COMMAND read_analog_input1_FSafeValue
{
	BLOCK function_block_1;
	INDEX 18;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_FSafeValue
		}
	}
}

//#tb: added
COMMAND write_analog_input1_FSafeValue
{
	BLOCK function_block_1;
	INDEX 18;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_FSafeValue
		}
		REPLY
		{
		}
	}
}


COMMAND read_analog_input1_alarm_hys
{
	BLOCK function_block_1;
	INDEX 19;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_alarm_hys
		}
	}
}

COMMAND write_analog_input1_alarm_hys
{
	BLOCK function_block_1;
	INDEX 19;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_alarm_hys
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_hi_hi_lim
{
	BLOCK function_block_1;
	INDEX 21;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_hi_hi_lim
		}
	}
}

COMMAND write_analog_input1_hi_hi_lim
{
	BLOCK function_block_1;
	INDEX 21;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_hi_hi_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_hi_lim
{
	BLOCK function_block_1;
	INDEX 23;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_hi_lim
		}
	}
}

COMMAND write_analog_input1_hi_lim
{
	BLOCK function_block_1;
	INDEX 23;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_hi_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_lo_lim
{
	BLOCK function_block_1;
	INDEX 25;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_lo_lim
		}
	}
}

COMMAND write_analog_input1_lo_lim
{
	BLOCK function_block_1;
	INDEX 25;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_lo_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_lo_lo_lim
{
	BLOCK function_block_1;
	INDEX 27;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			analog_input1_lo_lo_lim
		}
	}
}

COMMAND write_analog_input1_lo_lo_lim
{
	BLOCK function_block_1;
	INDEX 27;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			analog_input1_lo_lo_lim
		}
		REPLY
		{
		}
	}
}

COMMAND read_analog_input1_hi_hi_alm
{
	BLOCK function_block_1;
	INDEX 30;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-39
		{
			analog_input1_hi_hi_alm_unacknowledged, analog_input1_hi_hi_alm_state,
			analog_input1_hi_hi_alm_time_stamp, analog_input1_hi_hi_alm_subcode,
			analog_input1_hi_hi_alm_value
		}
	}
}

COMMAND read_analog_input1_hi_alm
{
	BLOCK function_block_1;
	INDEX 31;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-39
		{
			analog_input1_hi_alm_unacknowledged, analog_input1_hi_alm_state,
			analog_input1_hi_alm_time_stamp, analog_input1_hi_alm_subcode,
			analog_input1_hi_alm_value
		}
	}
}

COMMAND read_analog_input1_lo_alm
{
	BLOCK function_block_1;
	INDEX 32;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-39
		{
			analog_input1_lo_alm_unacknowledged, analog_input1_lo_alm_state,
			analog_input1_lo_alm_time_stamp, analog_input1_lo_alm_subcode,
			analog_input1_lo_alm_value
		}
	}
}

COMMAND read_analog_input1_lo_lo_alm
{
	BLOCK function_block_1;
	INDEX 33;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-39
		{
			analog_input1_lo_lo_alm_unacknowledged, analog_input1_lo_lo_alm_state,
			analog_input1_lo_lo_alm_time_stamp, analog_input1_lo_lo_alm_subcode,
			analog_input1_lo_lo_alm_value
		}
	}
}

COMMAND read_analog_input1_simulate
{
	BLOCK function_block_1;
	INDEX 34;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY		// DS-50
		{
			analog_input1_simulate_status_quality	<0xFC>,
			analog_input1_simulate_status_limit		<0x03>,
			analog_input1_simulate_value, 
			analog_input1_simulation_enabled
		}
	}
}

COMMAND write_analog_input1_simulate
{
	BLOCK function_block_1;
	INDEX 34;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST		// DS-50
		{
			analog_input1_simulate_status_quality	<0xFC>,
			analog_input1_simulate_status_limit		<0x03>,
			analog_input1_simulate_value, 
			analog_input1_simulation_enabled
		}
		REPLY
		{
		}
	}
}

METHOD method_set_status_limit_func1_AI
{
	ACCESS ONLINE;
	_CW_default_label

	CLASS		INPUT;
	DEFINITION
	{
		int	quality;
		int block_mode;

		quality = ivar_value(analog_input1_out_status_quality);
		if ((quality == 0x20) || (quality == 0x30))
			iassign(analog_input1_out_status_limit, 0);

		/*#tb
		block_mode	= ivar_value(analog_input1_target_mode);
		quality		= ivar_value(analog_input1_out_status_quality);
		if ((block_mode == BLOCK_MODE_MAN) && ((quality == 0x20) || (quality == 0x30)))
			iassign(analog_input1_out_status_limit, 0);
		*/
		save_values();	//#tb
	}
}

METHOD method_set_status_limit_func1_AI_Out_Quality
{
	ACCESS ONLINE;
	_CW_default_label

	CLASS		INPUT;
	DEFINITION
	{
		int	quality;
		int block_mode;

		//quality = ivar_value(analog_input1_out_status_quality);
		quality = igetval();
		if ((quality == 0x20) || (quality == 0x30))
			iassign(analog_input1_out_status_limit, 0);

		/*
		block_mode	= ivar_value(analog_input1_target_mode);
		quality		= ivar_value(analog_input1_out_status_quality);
		if ((block_mode == BLOCK_MODE_MAN) && ((quality == 0x20) || (quality == 0x30)))
			iassign(analog_input1_out_status_limit, 0);
		*/
		save_values();	//#tb
	}
}


METHOD method_set_status_limit_func1_AI_Sim_Limit
{
	ACCESS ONLINE;
	_CW_default_label

	CLASS		INPUT;
	DEFINITION
	{
		int	quality;
		int block_mode;

		quality = ivar_value(analog_input1_out_status_quality);
		if ((quality == 0x20) || (quality == 0x30))
			//iassign(analog_input1_out_status_limit, 0);
			isetval(0);

		/*
		block_mode	= ivar_value(analog_input1_target_mode);
		quality		= ivar_value(analog_input1_out_status_quality);
		if ((block_mode == BLOCK_MODE_MAN) && ((quality == 0x20) || (quality == 0x30)))
			iassign(analog_input1_out_status_limit, 0);
		*/
		save_values();	//#tb
	}
}


REFRESH Refresh_analog_input1_st_rev
{
	analog_input1_tag_desc,
	analog_input1_strategy,
	analog_input1_alert_key,
	analog_input1_target_mode,
	analog_input1_batch_id,
	analog_input1_batch_unit,
	analog_input1_batch_operation,
	analog_input1_batch_phase,
	analog_input1_pv_upper_range_value,
	analog_input1_pv_lower_range_value,
	analog_input1_out_upper_range_value,
	analog_input1_out_lower_range_value,
	analog_input1_out_unit,
	analog_input1_out_decimal_point,
	analog_input1_lin_type,
	analog_input1_channel,
	analog_input1_pv_ftime,
	analog_input1_FSafeType,
	analog_input1_FSafeValue,
	analog_input1_hi_hi_lim,
	analog_input1_hi_lim,
	analog_input1_lo_lim,
	analog_input1_lo_lo_lim,
	analog_input1_simulate_status_quality,
	analog_input1_simulate_status_limit,
	analog_input1_simulate_value, 
	analog_input1_simulation_enabled:
		analog_input1_st_rev
}

UNIT analog_input1_out_unit_relation
{
	analog_input1_out_unit:
		analog_input1_out_value,
		analog_input1_pv_upper_range_value,
		analog_input1_pv_lower_range_value,
		analog_input1_out_upper_range_value,
		analog_input1_out_lower_range_value,
		//#tb bug #2764 analog_input1_simulate_value,
		analog_input1_hi_hi_lim,
		analog_input1_hi_lim,
		analog_input1_lo_lim,
		analog_input1_lo_lo_lim
}

//#tb this was made because it's the only way to change the default value of this variable for PDM
//    cause PDM has his own sipastai files
#ifdef _PDM_
VARIABLE func1_AI_alarm_hys
{
	LABEL		[limit_hysteresis];
	HELP		[limit_hysteresis_help];
	CLASS		CONTAINED;
	HANDLING	READ & WRITE;
	
	POST_EDIT_ACTIONS
	{
		method_check_func1_AI_alarm_hys
	}

	TYPE		FLOAT
	{
		MIN_VALUE 0 ;
		DEFAULT_VALUE 0.09;
		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI(func1_AI_alarm_hys)
	}

}
#endif