/*
##	DS 21.11.2002 
##	This are (temporary) replacements for the special 
	Menu-style in PDM Online Menus	

*/



/*  ############# Reset Menu ############## */

MENU CW_Page_reset_device
{
	CW_access_for_onlinemenus
  LABEL	[menu_Device];
  HELP	[sitf_menu_reset_device_help];
  ITEMS
  {
    local_phys_factory_reset,
    phys_diagnosis
    meth_send_phys_factory_reset
  }
}

local_phys_factory_reset LIKE VARIABLE phys_factory_reset
{
	REDEFINE CLASS LOCAL;
}



METHOD 	meth_send_phys_factory_reset
{
	ACCESS ONLINE;
	CLASS INPUT;
	LABEL "Send values to device|de|Werte zum Gert senden";
	DEFINITION
	{
		/* created DS 22.11.2002
			This method shall send the local (local_~) simulation settings to device
		*/

		long l_phys_factory_reset;
	
		/*getting the local values*/
		l_phys_factory_reset = lvar_value(local_phys_factory_reset);
		
		
		/* sync the device variables with the local variables */
	
		lassign(phys_factory_reset, l_phys_factory_reset);

		
		WriteCommand(write_phys_factory_reset);
		ReadCommand(read_phys_factory_reset);
		
		/*getting the value from device*/
		l_phys_factory_reset = lvar_value(phys_factory_reset);
		/*sync with local */
		lassign(local_phys_factory_reset, l_phys_factory_reset);
		save_values();
	}
}

/* ########  write locking ########## */


MENU CW_OnlineDialog_write_locking
{
  CW_access_for_onlinemenus
  LABEL	[phys_write_locking];
  HELP	[phys_write_locking_help];
  ITEMS
  {
    local_phys_write_locking,
    meth_send_phys_write_locking
  }
}




local_phys_write_locking LIKE VARIABLE phys_write_locking
{
	REDEFINE CLASS LOCAL;
}



METHOD 	meth_send_phys_write_locking
{
	ACCESS ONLINE;
	CLASS INPUT;
	LABEL "Send values to device|de|Werte zum Gert senden";
	DEFINITION
	{
		/* created DS 22.11.2002
			This method shall send the local (local_~) simulation settings to device
		*/

		long l_phys_write_locking;
	
		/*getting the local values*/
		l_phys_write_locking = lvar_value(local_phys_write_locking);

		//#tb this is cause the device causes an error if non of the two values
		//are written to the device
		if((l_phys_write_locking != 0) || (l_phys_write_locking != 2457))
		{
			/* sync the device variables with the local variables */
			lassign(phys_write_locking, l_phys_write_locking);

			WriteCommand(write_phys_write_locking);
			ReadCommand(read_phys_write_locking);
			
			/*getting the value from device*/
			l_phys_write_locking = lvar_value(phys_write_locking);
			/*sync with local */
			lassign(local_phys_write_locking, l_phys_write_locking);
			save_values();
		}
	}
}
