//**********************************************************************
// Include: Global Defines
//**********************************************************************
#define  DDCCorrection

#define _CW_default_class   CLASS CONTAINED;
#define _CW_default_ACCESS	ACCESS ONLINE;
#define _CW_default_label	LABEL " ";



#define COMM_ERROR_DIALOG_AVAILABLE	// Error-Dialog kann auskommentiert werden

//----------------------------------------------------------

#include "SI_HlpM.inc"
#include "SI_FileM.inc"
#include "SI_OptM.inc"

#include "SI_YT.inc"		// Definition der Verlaufskurve

/***********************************************************************/

#define STATUS_RUN				2
#define STATUS_MAINTENANCE		5

/***********************************************************************/

#define	BLOCK_MODE_AUTO					0x08
#define	BLOCK_MODE_MAN					0x10
#define	BLOCK_MODE_OUT_OF_SERVICE		0x80

/***********************************************************************/

#define DEVICE_LF_IND			0
#define DEVICE_LF_COND			1

#define		UNIT_PH				1422
#define		UNIT_MV				1243
#define		UNIT_degK			1000
#define		UNIT_degC			1001
#define		UNIT_degF			1002
#define		UNIT_PERCENT		1342
#define		UNIT_mS_cm			1302
#define		UNIT_muS_cm			1552
#define		UNIT_kOhm_cm		1556
#define		UNIT_MOhm_cm		1555
#define		UNIT_TDS			1521	
#define		UNIT_PPM			1423	
#define		UNIT_S_m			1299	
#define		UNIT_mg_l			1558		


#define		EH_UNIT_degC		32
#define		EH_UNIT_degF		33
#define		EH_UNIT_MV			36
#define		EH_UNIT_PERCENT		57
#define		EH_UNIT_PH			59
#define		EH_UNIT_mS_cm		66
#define		EH_UNIT_muS_cm		67	
#define		EH_UNIT_TDS			106	
#define		EH_UNIT_PPM			139	
#define		EH_UNIT_S_m			240	
#define		EH_UNIT_kOhm_cm		241
#define		EH_UNIT_MOhm_cm		242		
#define		EH_UNIT_mg_l		245		

#define DEF_TEMP_UNITS							\
		DEFAULT_VALUE		EH_UNIT_degC;		\
		{ EH_UNIT_degC,		"degC"			},	\
		{ EH_UNIT_degF,		"degF"			}



#define STATUS_INPUT_LIMIT(quality)     				\
	IF ((quality) == 0x20)								\
	{								     				\
	  { 0x00,	[status_limit_OK]	     	},			\
	  { 0x03,	[status_limit_VALUE_CONSTANT]	}		\
	}									     			\
	ELSE												\
	{									     			\
		IF ((quality) == 0x30)							\
		{									     		\
			{ 0x00,	[status_limit_OK]		},			\
			{ 0x03,	[status_limit_VALUE_CONSTANT]	}	\
		}												\
		  ELSE											\
		{									     		\
			{ 0x00,	[status_limit_OK]		},			\
			{ 0x01,	[status_limit_UNDERFLOW]	},		\
			{ 0x02,	[status_limit_OVERFLOW]		},		\
			{ 0x03,	[status_limit_VALUE_CONSTANT]	}	\
		}												\
	}


#define STATUS_OUTPUT_LIMIT					\
		{ 0x00,	[status_limit_OK]		},	\
		{ 0x01,	[status_limit_UNDERFLOW]	},	\
		{ 0x02,	[status_limit_OVERFLOW]		},	\
		{ 0x03,	[status_limit_VALUE_CONSTANT]	}

// im MAN mode einzustellende Statuse
#define STATUS_INPUT_NO_RCAS				\
		{ 0x20,	[status_GOOD_00]	},		\
		{ 0x21,	[status_GOOD_01]	},		\
		{ 0x22,	[status_GOOD_02]	},		\
		{ 0x23,	[status_GOOD_03]	},		\
		{ 0x24,	[status_GOOD_04]	},		\
		{ 0x25,	[status_GOOD_05]	},		\
		{ 0x26,	[status_GOOD_06]	},		\
		{ 0x28,	[status_GOOD_08]	},		\
		{ 0x29,  [status_GOOD_09]	},		\
		{ 0x10,	[status_UNCERTAIN_00]	},	\
		{ 0x11,	[status_UNCERTAIN_01]	},	\
		{ 0x12,	[status_UNCERTAIN_02]	},	\
		{ 0x13,	[status_UNCERTAIN_03]	},	\
		{ 0x14,	[status_UNCERTAIN_04]	},	\
		{ 0x15,	[status_UNCERTAIN_05]	},	\
		{ 0x16,	[status_UNCERTAIN_06]	},	\
		{ 0x17,	[status_UNCERTAIN_07]	},	\
		{ 0x18,	[status_UNCERTAIN_08]	},	\
		{ 0x19,	[status_UNCERTAIN_09]	},	\
		{ 0x00,	[status_BAD_00]		},		\
		{ 0x01,	[status_BAD_01]		},		\
		{ 0x03,	[status_BAD_03]		},		\
		{ 0x04,	[status_BAD_04]		},		\
		{ 0x06,	[status_BAD_06]		},		\
		{ 0x07,	[status_BAD_07]		}

// im Normalbetrieb auftretende Statuse
#define STATUS_OUTPUT_NO_RCAS				\
		{ 0x20,	[status_GOOD_00]	},	\
		{ 0x21,	[status_GOOD_01]	},	\
		{ 0x22,	[status_GOOD_02]	},	\
		{ 0x23,	[status_GOOD_03]	},	\
		{ 0x24,	[status_GOOD_04]	},	\
		{ 0x25,	[status_GOOD_05]	},	\
		{ 0x26,	[status_GOOD_06]	}	\
		{ 0x28,	[status_GOOD_08]	},	\
		{ 0x29,  [status_GOOD_09]	},	\
		{ 0x10,	[status_UNCERTAIN_00]	},	\
		{ 0x11,	[status_UNCERTAIN_01]	},	\
		{ 0x12,	[status_UNCERTAIN_02]	},	\
		{ 0x13,	[status_UNCERTAIN_03]	},	\
		{ 0x14,	[status_UNCERTAIN_04]	},	\
		{ 0x15,	[status_UNCERTAIN_05]	},	\
		{ 0x16,	[status_UNCERTAIN_06]	},	\
		{ 0x17,	[status_UNCERTAIN_07]	},	\
		{ 0x18,	[status_UNCERTAIN_08]	},	\
		{ 0x19,	[status_UNCERTAIN_09]	},	\
		{ 0x00,	[status_BAD_00]		},	\
		{ 0x01,	[status_BAD_01]		},	\
		{ 0x02,	[status_BAD_02]		},	\
		{ 0x03,	[status_BAD_03]		},	\
		{ 0x04,	[status_BAD_04]		},	\
		{ 0x05,	[status_BAD_05]		},	\
		{ 0x06,	[status_BAD_06]		},	\
		{ 0x07,	[status_BAD_07]		}
