//******************************************************************************
//****	VH-Matrix MENU    ******************************************************
//******************************************************************************

MENU Off_Page_diagnosis_manufact_specific
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	//LABEL	[lbl_Page_diagnosis_manufact_specific];
	LABEL [menu_table_EH_Std_Matrix];
	ITEMS
	{
		Off_Page_diagnosis_MainParam,
		Off_Page_diagnosis_DeviceState,
		Off_Page_diagnosis_CalibData,

#ifdef _PDM_
	#ifdef DEVICE_PARAM_PH
		Off_Page_diagnosis_TopcCal,
	#endif
#endif

#ifdef DEVICE_PARAM_LF
		Off_Page_diagnosis_ParamSet,
#endif

#ifdef _PDM_
		Off_Page_diagnosis_ChemoClean,
#endif
		Off_Page_diagnosis_Controller,
		Off_Page_diagnosis_LimitSwitch,

#ifdef _PDM_
	#ifdef DEVICE_PARAM_PH
		Off_Page_diagnosis_Validate,
	#endif
#endif

		Off_Page_diagnosis_SensorData,
		Off_Page_diagnosis_DeviceData
		#ifdef _PDM_
		Page_Simulation_offline
		#endif
	}
}

MENU Off_Page_diagnosis_MainParam
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_MainParam];
	ITEMS
	{
#ifdef _PDM_
		manufact_Unit_CH1,
		manufact_MeasValue_CH1,
		manufact_Temp_CH1,
		SEPARATOR,
		manufact_Unit_CH2,
		manufact_MeasValue_CH2,
		manufact_Temp_CH2,
		SEPARATOR,
		manufact_Unit_Temp,
		manufact_Hold_State,
		manufact_Damping_MeasVal,
		manufact_Damping_Temp
#else
		manufact_Damping_MeasVal,
		manufact_Damping_Temp
#endif
		
	}
}

MENU Off_Page_diagnosis_DeviceState
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_DeviceState];
	ITEMS
	{
		manufact_Hold,
		#ifdef DEVICE_PARAM_PH
			manufact_Device_Funct
		#endif
		#ifdef _PDM_
			manufact_Current_Error,
			refReset
		#else
			phys_pa_set_unit_to_bus_offline
		#endif
	}
}

MENU Off_Page_diagnosis_CalibData
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_CalibData];
  ITEMS
  {
#ifdef DEVICE_PARAM_PH
		manufact_Unit_Zeropoint_CH1,
		manufact_Zeropoint_CH1,
		manufact_Slope_CH1,
#endif
#ifdef DEVICE_PARAM_LF
		manufact_Sensor_Type,
		//SEPARATOR,
		manufact_Cell_Const_CH1,
		manufact_Adaption_Factor_CH1,
		manufact_Air_Set_CH1,
#endif
		manufact_Time_CH1,
		manufact_Date_CH1,
		//SEPARATOR,
#ifdef DEVICE_PARAM_PH
		manufact_Unit_Zeropoint_CH2,
		manufact_Zeropoint_CH2,
		manufact_Slope_CH2,
#endif
#ifdef DEVICE_PARAM_LF
		manufact_Cell_Const_CH2,
		manufact_Adaption_Factor_CH2,
		manufact_Air_Set_CH2,
#endif
		manufact_Time_CH2,
		manufact_Date_CH2
  }
}


#ifdef _PDM_
MENU Off_Page_diagnosis_TopcCal
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_TopcCal];
	ITEMS
	{
		refTopcal,
		//manufact_Device_Funct, //thbe
		manufact_Active_Program (READ_ONLY),
		manufact_Automatic (READ_ONLY),
		manufact_Extern_Control (READ_ONLY),
		manufact_Topcal_Hold (READ_ONLY),
		manufact_Armatur_Position (READ_ONLY)
	}
#ifndef SHOWALLMENUS
	VALIDITY
		IF (manufact_Device_Funct <= DEVICE_FUNCT_TOPCLEAN) { TRUE;}
		ELSE { FALSE;}
#endif
}
#endif

MENU Off_Page_diagnosis_ParamSet
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_ParamSet];
	ITEMS
	{
		manufact_CurrentPS,
		manufact_NumberBinInputs,
		manufact_ControlBinInput
	}
}

#ifdef _PDM_
MENU Off_Page_diagnosis_ChemoClean
{
	LABEL	[lbl_Page_diagnosis_ChemoClean];
	ITEMS
	{
		refChemoclean,
		manufact_Active_Program_CClean (READ_ONLY),
		manufact_Automatic_CClean,// (READ_ONLY),
		manufact_Extern_Control_CClean// (READ_ONLY)
	}
}
#endif


MENU Off_Page_diagnosis_Controller
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_Controller];
  ITEMS
  {
	#ifdef _PDM_
		refController,
		manufact_Controller (READ_ONLY),
	#else
		manufact_Controller,
	#endif
		manufact_Contr_Unit_Setpoint	
	#ifdef _PDM_
		,manufact_Contr_Setpoint (READ_ONLY),
		manufact_Contr_Set_Value (READ_ONLY),
		manufact_Hold (READ_ONLY),
		manufact_Hold_State (READ_ONLY)
	#endif
  }
}

MENU Off_Page_diagnosis_LimitSwitch
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_LimitSwitch];
  ITEMS
  {
		Off_Page_diagnosis_LimitSwitch1,
		Off_Page_diagnosis_LimitSwitch2,
		Off_Page_diagnosis_LimitSwitch3,
		Off_Page_diagnosis_LimitSwitch4,
		Off_Page_diagnosis_LimitSwitch5
  }
}

MENU Off_Page_diagnosis_LimitSwitch1
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_LimitSwitch1];
  ITEMS
  {
		manufact_LS1_function,
		manufact_LS1_unit,
		manufact_LS1_alarm_threshold,
		manufact_LS1_switch_off_pnt,
		manufact_LS1_switch_on_pnt
  }
}

MENU Off_Page_diagnosis_LimitSwitch2
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_LimitSwitch2];
  ITEMS
  {
		manufact_LS2_function,
		manufact_LS2_unit,
		manufact_LS2_alarm_threshold,
		manufact_LS2_switch_off_pnt,
		manufact_LS2_switch_on_pnt
  }
}

MENU Off_Page_diagnosis_LimitSwitch3
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_LimitSwitch3];
  ITEMS
  {
		manufact_LS3_function,
		manufact_LS3_unit,
		manufact_LS3_alarm_threshold,
		manufact_LS3_switch_off_pnt,
		manufact_LS3_switch_on_pnt
  }
}

MENU Off_Page_diagnosis_LimitSwitch4
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_LimitSwitch4];
  ITEMS
  {
		manufact_LS4_function,
		manufact_LS4_unit,
		manufact_LS4_alarm_threshold,
		manufact_LS4_switch_off_pnt,
		manufact_LS4_switch_on_pnt
  }
}

MENU Off_Page_diagnosis_LimitSwitch5
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_LimitSwitch5];
  ITEMS
  {
		manufact_LS5_function,
		manufact_LS5_unit,
		manufact_LS5_alarm_threshold,
		manufact_LS5_switch_off_pnt,
		manufact_LS5_switch_on_pnt
  }
}


#ifdef _PDM_
	MENU Off_Page_diagnosis_Validate
	{
		#ifndef _PDM_
		ACCESS OFFLINE;
		#endif
		LABEL	[lbl_Page_diagnosis_Validate];
		ITEMS
		{
			Off_Page_diagnosis_Buffer1,
			Off_Page_diagnosis_Buffer2
		}
	#ifndef SHOWALLMENUS

		VALIDITY
			IF (manufact_Device_Funct == DEVICE_FUNCT_TOPCAL) { TRUE;}
			ELSE { FALSE;}
	#endif
	}

	MENU Off_Page_diagnosis_Buffer1
	{
		#ifndef _PDM_
		ACCESS OFFLINE;
		#endif
		LABEL	[lbl_Page_diagnosis_Buffer1];
		ITEMS
		{
			//manufact_Device_Funct,	//thbe
			refValidtate,
			manufact_Val_Setpoint_Buffer_1,
			manufact_Val_Actual_value_Buffer_1,
			manufact_Val_Delta_Buffer_1,
			manufact_Val_Temp_Buffer_1,
			
			manufact_Val_Time_Buffer_1,
			manufact_Val_Date_Buffer_1
		}
	}

	MENU Off_Page_diagnosis_Buffer2
	{
		#ifndef _PDM_
		ACCESS OFFLINE;
		#endif
		LABEL	[lbl_Page_diagnosis_Buffer2];
		ITEMS
		{
			refValidtate,
			manufact_Val_Setpoint_Buffer_2,
			manufact_Val_Actual_value_Buffer_2,
			manufact_Val_Delta_Buffer_2,
			manufact_Val_Temp_Buffer_2,
			manufact_Val_Time_Buffer_2,
			manufact_Val_Date_Buffer_2
		}
	}
#endif


MENU Off_Page_diagnosis_SensorData
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_SensorData];
  ITEMS
  {
		manufact_Sensor_Serial_No,
		manufact_Sensor_Lower_Limit,
#ifdef DEVICE_PARAM_PH
		manufact_Sensor_Upper_Limit
#endif
#ifdef DEVICE_PARAM_LF
		manufact_Sensor_Upper_Limit,
		manufact_Sensor_Type
#endif
  }
}

MENU Off_Page_diagnosis_DeviceData
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_DeviceData];
	ITEMS
	{
	#ifdef _PDM_
		phys_tag_desc,
		phys_device_bus_adress,
		phys_ehc_actual_error,
		phys_ehc_last_error,
	#endif
		//method_Clear_Last_Error
		manufact_SW_Version,
		manufact_HW_Version,
	#ifdef _PDM_
		refSet_Unit_To_Bus
	#else
		//#tb method_Set_Unit_To_Bus_offline
	#endif

	}
}
