//******************************************************************************
//****	VH-Matrix MENU  for PDM Maintenance  ******************************************************
//******************************************************************************

MENU Off_M_Page_diagnosis_manufact_specific
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_manufact_specific];
	ITEMS
	{
		Off_M_Page_diagnosis_MainParam (READ_ONLY),
		Off_M_Page_diagnosis_DeviceState (READ_ONLY),
		Off_M_Page_diagnosis_CalibData (READ_ONLY),
#ifdef DEVICE_PARAM_PH
		Off_M_Page_diagnosis_TopcCal (READ_ONLY),
#endif
#ifdef DEVICE_PARAM_LF
		Off_M_Page_diagnosis_ParamSet (READ_ONLY),
#endif
		Off_M_Page_diagnosis_ChemoClean ,
		Off_M_Page_diagnosis_Controller,
		Off_M_Page_diagnosis_LimitSwitch ,
		Off_M_Page_diagnosis_SensorData ,
		Off_M_Page_diagnosis_DeviceData
	}
}

MENU Off_M_Page_diagnosis_MainParam
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_MainParam];
	ITEMS
	{
		manufact_Damping_MeasVal(READ_ONLY),
		manufact_Damping_Temp (READ_ONLY)
	}
}

MENU Off_M_Page_diagnosis_DeviceState
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_DeviceState];
	ITEMS
	{
		manufact_Hold (READ_ONLY),
#ifdef DEVICE_PARAM_PH
		manufact_Device_Funct (READ_ONLY)
#endif
	}
}

MENU Off_M_Page_diagnosis_CalibData
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_CalibData];
  ITEMS
  {
#ifdef DEVICE_PARAM_PH
		manufact_Unit_Zeropoint_CH1 (READ_ONLY),
		manufact_Zeropoint_CH1 (READ_ONLY),
		manufact_Slope_CH1 (READ_ONLY),
#endif
#ifdef DEVICE_PARAM_LF
		manufact_Sensor_Type (READ_ONLY),
		//SEPARATOR (READ_ONLY),
		manufact_Cell_Const_CH1 (READ_ONLY),
		manufact_Adaption_Factor_CH1 (READ_ONLY),
		manufact_Air_Set_CH1 (READ_ONLY),
#endif
		manufact_Time_CH1 (READ_ONLY),
		manufact_Date_CH1 (READ_ONLY),
		//SEPARATOR (READ_ONLY),
#ifdef DEVICE_PARAM_PH
		manufact_Unit_Zeropoint_CH2 (READ_ONLY),
		manufact_Zeropoint_CH2 (READ_ONLY),
		manufact_Slope_CH2 (READ_ONLY),
#endif
#ifdef DEVICE_PARAM_LF
		manufact_Cell_Const_CH2 (READ_ONLY),
		manufact_Adaption_Factor_CH2 (READ_ONLY),
		manufact_Air_Set_CH2 (READ_ONLY),
#endif
		manufact_Time_CH2 (READ_ONLY),
		manufact_Date_CH2 (READ_ONLY)
  }
}

MENU Off_M_Page_diagnosis_TopcCal
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_TopcCal];
	ITEMS
	{
		manufact_Active_Program (READ_ONLY),
		manufact_Automatic (READ_ONLY),
		manufact_Extern_Control (READ_ONLY),
		manufact_Topcal_Hold (READ_ONLY),
		manufact_Armatur_Position (READ_ONLY)
	}
#ifndef SHOWALLMENUS
	VALIDITY
		IF (manufact_Device_Funct <= DEVICE_FUNCT_TOPCLEAN) { TRUE;}
		ELSE { FALSE;}
#endif
}

MENU Off_M_Page_diagnosis_ParamSet
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_ParamSet];
	ITEMS
	{
		manufact_CurrentPS (READ_ONLY),
		manufact_NumberBinInputs (READ_ONLY),
		manufact_ControlBinInput (READ_ONLY)
	}
}

MENU Off_M_Page_diagnosis_ChemoClean
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_ChemoClean];
	ITEMS
	{
		manufact_Active_Program_CClean (READ_ONLY),
		manufact_Automatic_CClean (READ_ONLY),
		manufact_Extern_Control_CClean (READ_ONLY)
	}
}

MENU Off_M_Page_diagnosis_Controller
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_Controller];
  ITEMS
  {
		manufact_Controller (READ_ONLY),
		manufact_Contr_Unit_Setpoint (READ_ONLY),
  }
}

MENU Off_M_Page_diagnosis_LimitSwitch
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_LimitSwitch];
  ITEMS
  {
		Off_M_Page_diagnosis_LimitSwitch1 ,
		Off_M_Page_diagnosis_LimitSwitch2 ,
		Off_M_Page_diagnosis_LimitSwitch3 ,
		Off_M_Page_diagnosis_LimitSwitch4 ,
		Off_M_Page_diagnosis_LimitSwitch5
  }
}

MENU Off_M_Page_diagnosis_LimitSwitch1
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_LimitSwitch1];
  ITEMS
  {
		manufact_LS1_function (READ_ONLY),
		manufact_LS1_unit (READ_ONLY),
		manufact_LS1_alarm_threshold (READ_ONLY),
		manufact_LS1_switch_off_pnt (READ_ONLY),
		manufact_LS1_switch_on_pnt (READ_ONLY)
  }
}

MENU Off_M_Page_diagnosis_LimitSwitch2
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_LimitSwitch2];
  ITEMS
  {
		manufact_LS2_function (READ_ONLY),
		manufact_LS2_unit (READ_ONLY),
		manufact_LS2_alarm_threshold (READ_ONLY),
		manufact_LS2_switch_off_pnt (READ_ONLY),
		manufact_LS2_switch_on_pnt (READ_ONLY)
  }
}

MENU Off_M_Page_diagnosis_LimitSwitch3
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_LimitSwitch3];
  ITEMS
  {
		manufact_LS3_function (READ_ONLY),
		manufact_LS3_unit (READ_ONLY),
		manufact_LS3_alarm_threshold (READ_ONLY),
		manufact_LS3_switch_off_pnt (READ_ONLY),
		manufact_LS3_switch_on_pnt (READ_ONLY)
  }
}

MENU Off_M_Page_diagnosis_LimitSwitch4
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_LimitSwitch4];
  ITEMS
  {
		manufact_LS4_function (READ_ONLY),
		manufact_LS4_unit (READ_ONLY),
		manufact_LS4_alarm_threshold (READ_ONLY),
		manufact_LS4_switch_off_pnt (READ_ONLY),
		manufact_LS4_switch_on_pnt (READ_ONLY)
  }
}

MENU Off_M_Page_diagnosis_LimitSwitch5
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_LimitSwitch5];
  ITEMS
  {
		manufact_LS5_function (READ_ONLY),
		manufact_LS5_unit (READ_ONLY),
		manufact_LS5_alarm_threshold (READ_ONLY),
		manufact_LS5_switch_off_pnt (READ_ONLY),
		manufact_LS5_switch_on_pnt (READ_ONLY)
  }
}

MENU Off_M_Page_diagnosis_SensorData
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_SensorData];
  ITEMS
  {
		manufact_Sensor_Serial_No (READ_ONLY),
		manufact_Sensor_Lower_Limit (READ_ONLY),
#ifdef DEVICE_PARAM_PH
		manufact_Sensor_Upper_Limit (READ_ONLY)
#endif
#ifdef DEVICE_PARAM_LF
		manufact_Sensor_Upper_Limit (READ_ONLY),
		manufact_Sensor_Type (READ_ONLY)
#endif
  }
}

MENU Off_M_Page_diagnosis_DeviceData
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_DeviceData];
	ITEMS
	{
		manufact_SW_Version (READ_ONLY),
		manufact_HW_Version (READ_ONLY)
	}
}
