//************************ COPYRIGHT INFORMATION ***********************
//*                                                                    *
//*                        COPYRIGHT  (C)   2002                       *
//*                                                                    *
//*  BY ENDRESS + HAUSER CONDUCTA GMBH + Co. ,  D-70839 GERLINGEN      *
//*                                                                    *
//*                                                                    *
//**********************************************************************
//*********************** MODULEHEADER VERSION 2.0 *********************
//*                                                                    *
//*  MODULENAME Mycom_LF_1_2x		Device Description                 *
//*                                                                    *
//*  DEVICE	   Mycom LFI PA                                            *
//*                                                                    *
//****************************  CHANGES  *******************************
//*                                                                    *
//*--------------------------------------------------------------------*
//* PROGRAMMER *   DATE   *              CHANGES             * VERSION *
//*--------------------------------------------------------------------*
//* tb  	  * 22.04.03 * file renamed                     * 1.0      *
//* FEI/Fe	  * 18.12.02 * First Release                    * 1.0      *
//* PCPS	    * 25.02.13 * Identcheck corrected           * 1.2        *
//*			  *			 *							        *		   *
//**********************************************************************
//* FUNCTIONAL DESCRIPTION OF THE MODULE:                              *
//*																	   *
//*																	   *
//**********************************************************************

#ifndef _PDM_
	MANUFACTURER		ENDRESS_HAUSER,
	DEVICE_TYPE			0x1537,
#else
	MANUFACTURER		0x11,
	DEVICE_TYPE			0x1537,
#endif
DEVICE_REVISION 	2,
DD_REVISION			2

#ifndef _PDM_
	#pragma CW DO_SDK_ANALYSIS 1 // (EK) 10 Nov 2003 
#endif

#define PHYSICAL_BLOCK_PARENT_CLASS		5,	[phys_blk_parent_class_ANALYSER]

#ifdef _PDM_
	#define ENABLE_IDENTCHECK //schaltet ein Makro frei
	#define DEFAULT_MANUFACTURER_ID	17 
	#define CHECK_PROFILE_REV	768  // 768 Hexadezimal entsprich 300 also 3.00

  #define CHECK_DEVICE_TYPE "CLM153P"
	#define CHECK_DEVICE_TYPE_UNTIL_DIGIT 7		  /* Define length of device type string here which has to match the device type */
	
	#define CHECK_SOFTWARE_VERSION "1.2" // entspr. V1.2
	#define CHECK_SOFTWARE_VERSION_UNTIL_DIGIT  3  /* Define length of device type string here which has to match the device type */
  
	#include "sipastident01MyComS_.inc"
#else
	/* Ident Check - inserted 2003-08-18 by AT */
	#define __DDC__phys_device_man_id_VALUE 0x11
	#define __DDC__phys_device_id_VALUE { 0, "CLM153P         " }
	#define __DDC__software_rev_VALUE { 0, "1.2             " }
	//#define __DDC__hardware_rev_VALUE { 0, "X.X" }
	#define __DDC__profile_rev_VALUE { 0x0300, "3.0" }
	#define __DDC__ident_number_VALUE { 0x1537, "Mycom S / CLM 153 ind / PA / V1.20" }
	#include "..\..\..\..\..\__DDC__ident_check.ddl"
	/* End of Ident Check */
#endif

//activate SHOWALLMENUS if you like to see the Topclean/Topcal menu anyway
//#define SHOWALLMENUS


#define CW_access_for_offlinemenus	ACCESS OFFLINE;
#define CW_access_for_onlinemenus	ACCESS ONLINE;

#ifdef _PDM_
	#define DEF_device_id_PB	"CLM153P"
#else
	#define DEF_device_id_PB	"Mycom LF 1_2x"
#endif
#define CERTIFICATE_DEVICE	"ZELM 00 ATEX 0033"

#include "DEFINE_EHC.DDL"

#define DEVICE_PARAM_LF

#define DEFAULT_SENSOR_TYPE		DEVICE_LF_IND

#define	DEVICE_FUNCT_TOPCAL		0
#define	DEVICE_FUNCT_TOPCLEAN	1
#define	DEVICE_FUNCT_MYCOM_1	2
#define	DEVICE_FUNCT_MYCOM_2	3

#define DISP_FORMAT_LIMIT_SWITCH			\
			CASE EH_UNIT_TDS:		"4.2f";	\
			CASE EH_UNIT_PPM:		"4.2f";	\
			CASE EH_UNIT_S_m:		"4.3f";	\
			CASE EH_UNIT_mg_l:		"4.2f";	\
			CASE EH_UNIT_PERCENT:	"4.2f";	\
			CASE EH_UNIT_mS_cm:		"4.3f";	\
			CASE EH_UNIT_muS_cm:	"4.3f";	\
			CASE EH_UNIT_kOhm_cm:	"4.3f";	\
			CASE EH_UNIT_MOhm_cm:	"4.3f";	\
			CASE EH_UNIT_degC:		"4.1f";	\
			CASE EH_UNIT_degF:		"4.1f";	\
			DEFAULT:				"4.2f";
						
#define MIN_FORMAT_LIMIT_SWITCH				\
			CASE EH_UNIT_TDS:		0;		\
			CASE EH_UNIT_PPM:		0;		\
			CASE EH_UNIT_S_m:		0;		\
			CASE EH_UNIT_mg_l:		0;		\
			CASE EH_UNIT_PERCENT:	0;		\
			CASE EH_UNIT_mS_cm:		0;		\
			CASE EH_UNIT_muS_cm:	0;		\
			CASE EH_UNIT_kOhm_cm:	0;		\
			CASE EH_UNIT_MOhm_cm:	0;		\
			CASE EH_UNIT_degC:		-35;	\
			CASE EH_UNIT_degF:		-31;	\
			DEFAULT:				0;
							
#define MAX_FORMAT_LIMIT_SWITCH				\
			CASE EH_UNIT_TDS:		99.99;	\
			CASE EH_UNIT_PPM:		99.99;	\
			CASE EH_UNIT_S_m:		200;	\
			CASE EH_UNIT_mg_l:		99.99;	\
			CASE EH_UNIT_PERCENT:	99.99;	\
			CASE EH_UNIT_mS_cm:		2000;	\
			CASE EH_UNIT_muS_cm:	20000;	\
			CASE EH_UNIT_kOhm_cm:	5000;	\
			CASE EH_UNIT_MOhm_cm:	500;	\
			CASE EH_UNIT_degC:		250;	\
			CASE EH_UNIT_degF:		482;	\
			DEFAULT:				0;


#define DISPLAY_FORMAT_LS_1_VALUES			\
	DISPLAY_FORMAT							\
		SELECT(manufact_LS1_unit)			\
		{									\
			DISP_FORMAT_LIMIT_SWITCH		\
		}									\
	MIN_VALUE								\
		SELECT(manufact_LS1_unit)			\
		{									\
			MIN_FORMAT_LIMIT_SWITCH			\
		}									\
	MAX_VALUE								\
		SELECT(manufact_LS1_unit)			\
		{									\
			MAX_FORMAT_LIMIT_SWITCH			\
		}

#define DISPLAY_FORMAT_LS_2_VALUES			\
	DISPLAY_FORMAT							\
		SELECT(manufact_LS2_unit)			\
		{									\
			DISP_FORMAT_LIMIT_SWITCH		\
		}									\
	MIN_VALUE								\
		SELECT(manufact_LS2_unit)			\
		{									\
			MIN_FORMAT_LIMIT_SWITCH			\
		}									\
	MAX_VALUE								\
		SELECT(manufact_LS2_unit)			\
		{									\
			MAX_FORMAT_LIMIT_SWITCH			\
		}

#define DISPLAY_FORMAT_LS_3_VALUES			\
	DISPLAY_FORMAT							\
		SELECT(manufact_LS3_unit)			\
		{									\
			DISP_FORMAT_LIMIT_SWITCH		\
		}									\
	MIN_VALUE								\
		SELECT(manufact_LS3_unit)			\
		{									\
			MIN_FORMAT_LIMIT_SWITCH			\
		}									\
	MAX_VALUE								\
		SELECT(manufact_LS3_unit)			\
		{									\
			MAX_FORMAT_LIMIT_SWITCH			\
		}

#define DISPLAY_FORMAT_LS_4_VALUES			\
	DISPLAY_FORMAT							\
		SELECT(manufact_LS4_unit)			\
		{									\
			DISP_FORMAT_LIMIT_SWITCH		\
		}									\
	MIN_VALUE								\
		SELECT(manufact_LS4_unit)			\
		{									\
			MIN_FORMAT_LIMIT_SWITCH			\
		}									\
	MAX_VALUE								\
		SELECT(manufact_LS4_unit)			\
		{									\
			MAX_FORMAT_LIMIT_SWITCH			\
		}

#define DISPLAY_FORMAT_LS_5_VALUES			\
	DISPLAY_FORMAT							\
		SELECT(manufact_LS5_unit)			\
		{									\
			DISP_FORMAT_LIMIT_SWITCH		\
		}									\
	MIN_VALUE								\
		SELECT(manufact_LS5_unit)			\
		{									\
			MIN_FORMAT_LIMIT_SWITCH			\
		}									\
	MAX_VALUE								\
		SELECT(manufact_LS5_unit)			\
		{									\
			MAX_FORMAT_LIMIT_SWITCH			\
		}

#define DISPLAY_FORMAT_PV						\
				CASE UNIT_muS_cm:	"4.3f";		\
				CASE UNIT_mS_cm:	"4.3f";		\
				CASE UNIT_MOhm_cm:	"4.3f";		\
				CASE UNIT_kOhm_cm:	"4.3f";		\
				CASE UNIT_degK:		"4.0f";		\
				CASE UNIT_degC:		"4.1f";		\
				CASE UNIT_degF:		"4.1f";		\
				CASE UNIT_PERCENT:	"4.2f";		\
				CASE UNIT_TDS:		"4.2f";		\
				CASE UNIT_PPM:		"4.2f";		\
				CASE UNIT_S_m:		"4.3f";		\
				CASE UNIT_mg_l:		"4.2f";		\
				DEFAULT:			"5.5f";

#define DISPLAY_FORMAT_TRANS1_PV			\
	DISPLAY_FORMAT							\
			SELECT(trans1_pv_unit)			\
			{								\
				DISPLAY_FORMAT_PV			\
			}

#define DISPLAY_FORMAT_TRANS2_PV			\
	DISPLAY_FORMAT							\
			SELECT(trans2_pv_unit)			\
			{								\
				DISPLAY_FORMAT_PV			\
			}

#define DISPLAY_FORMAT_TRANS3_PV			\
	DISPLAY_FORMAT							\
			SELECT(trans3_pv_unit)			\
			{								\
				DISPLAY_FORMAT_PV			\
			}

#define DISPLAY_FORMAT_TRANS4_PV			\
	DISPLAY_FORMAT							\
			SELECT(trans4_pv_unit)			\
			{								\
				DISPLAY_FORMAT_PV			\
			}

#define DEF_TRANS_UNIT_DEFAULT	DEFAULT_VALUE UNIT_mS_cm;
#define DEF_TRANS_UNIT			\
		{ UNIT_degK, [unit_1000]	},	\
		{ UNIT_degC, [unit_1001]	},	\
		{ UNIT_degF, [unit_1002]	},	\
		{ UNIT_PERCENT, "%"			},	\
		{ UNIT_muS_cm, "S/cm"		},	\
		{ UNIT_mS_cm, "mS/cm"		},	\
		{ 1551, "S/cm"		},	\
		{ 1554, "S/m"		},	\
		{ 1553, "mS/m"		},	\
		{ UNIT_S_m, "S/m"		},	\
		{ UNIT_MOhm_cm, "MOhm/cm"	},	\
		{ UNIT_kOhm_cm, "kOhm/cm"	},	\
		{ 1557, "rel.%"		},	\
		{ UNIT_mg_l, "mg/l"		},	\
		{ 1425, "ppt"		},	\
		{ UNIT_PPM, "ppm"		},	\
		{ UNIT_TDS, "TDS"		},	\
		{ 1997, "-"			},	\
		{ UNIT_PH, "pH"		},	\
		{ UNIT_MV, "mV"		}

#define DEF_UNITS_DEVICE						\
		DEFAULT_VALUE		EH_UNIT_muS_cm;		\
		{ EH_UNIT_degC,		"degC"			},	\
		{ EH_UNIT_degF,		"degF"			},	\
		{ EH_UNIT_PERCENT,	"%"				},	\
		{ EH_UNIT_mS_cm,	"mS/cm"			},	\
		{ EH_UNIT_muS_cm,	"S/cm"			},	\
		{ 246,				"S/cm"			},	\
		{ 247,				"S/m"			},	\
		{ 248,				"mS/m"			},	\
		{ EH_UNIT_TDS,		"TDS"			},	\
		{ EH_UNIT_PPM,		"ppm"			},	\
		{ EH_UNIT_S_m,		"S/m"			},	\
		{ EH_UNIT_kOhm_cm,	"kOhm/cm"		},	\
		{ EH_UNIT_MOhm_cm,	"MOhm/cm"		},	\
		{ EH_UNIT_mg_l,		"mg/l"		}
	
						
#define INDEX_manufact_Reset					112
#define INDEX_manufact_Time_CH2					121
#define INDEX_manufact_Date_CH2					122
#define INDEX_manufact_Active_Program_CClean	126
#define INDEX_manufact_Automatic_CClean			127
#define INDEX_manufact_Extern_Control_CClean	128
#define INDEX_manufact_Controller				129
#define INDEX_manufact_Contr_Setpoint			130
#define INDEX_manufact_Contr_Set_Value			131
#define INDEX_manufact_Contr_Unit_Setpoint		132
#define INDEX_manufact_LS1_unit					133
#define INDEX_manufact_LS2_unit					134
#define INDEX_manufact_LS3_unit					135
#define INDEX_manufact_LS4_unit					136
#define INDEX_manufact_LS5_unit					137
#define INDEX_manufact_LS1_function				138
#define INDEX_manufact_LS2_function				139
#define INDEX_manufact_LS3_function				140
#define INDEX_manufact_LS4_function				141
#define INDEX_manufact_LS5_function				142
#define INDEX_manufact_LS1_alarm_threshold		143
#define INDEX_manufact_LS2_alarm_threshold		144
#define INDEX_manufact_LS3_alarm_threshold		145
#define INDEX_manufact_LS4_alarm_threshold		146
#define INDEX_manufact_LS5_alarm_threshold		147
#define INDEX_manufact_LS1_switch_off_pnt		148
#define INDEX_manufact_LS2_switch_off_pnt		149
#define INDEX_manufact_LS3_switch_off_pnt		150
#define INDEX_manufact_LS4_switch_off_pnt		151
#define INDEX_manufact_LS5_switch_off_pnt		152
#define INDEX_manufact_LS1_switch_on_pnt		153
#define INDEX_manufact_LS2_switch_on_pnt		154
#define INDEX_manufact_LS3_switch_on_pnt		155
#define INDEX_manufact_LS4_switch_on_pnt		156
#define INDEX_manufact_LS5_switch_on_pnt		157
#define INDEX_manufact_Sensor_Serial_No			158
#define INDEX_manufact_Sensor_Lower_Limit		159
#define INDEX_manufact_Sensor_Upper_Limit		160
#define INDEX_manufact_SW_Version				161
#define INDEX_manufact_HW_Version				162

//**********************************************************************
//    Physical Block		(Slot 1)
//**********************************************************************

#define LOCKING_LIST				\
		DEFAULT_VALUE	2457;		\
		{ 2457,	[off]		},	\
		{ 0,	[on]		}

//#tb #include "PB_EHC.DDL"
#define DEFAULT_phys_ident_number	1
#ifdef _PDM_
	//include "sipast.inc"
	#include "PB_EHC.DDL"
#else
	#include "SIPASTPB_300.inc"
#endif


//**********************************************************************
//    Transducer Block		(Slot 1-4)
//**********************************************************************

#include "TB1_EHC.DDL"
#include "TB2_EHC.DDL"
#include "TB3_EHC.DDL"
#include "TB4_EHC.DDL"


#define FUNC1_CHANNEL_LIST { 0x0109, [trans_meas_1] }

#define FUNC1_UNIT_LIST					DEF_TRANS_UNIT
#define FUNC_AI_FAIL_SAFE_VALUE			0
#define FUNC_AI_STORING_LAST_SETPOINT	1
#define NO_func1_AI_out_unit_text

#define DEFAULT_VALUE_func1_AI_out_unit UNIT_mS_cm
#define DEFAULT_VALUE_func1_lower_range_value 0
#define DEFAULT_VALUE_func1_upper_range_value 200

#ifdef _PDM_
	#include "SIPASTAI_300.inc"
#else
	#include "SIPASTAI1_300.inc"
#endif

#define FUNC2_CHANNEL_LIST { 0x0209, [trans_temp_temperature_1] }
#define FUNC2_UNIT_LIST					DEF_TRANS_UNIT
#define FUNC_AI_FAIL_SAFE_VALUE			0
#define FUNC_AI_STORING_LAST_SETPOINT	1
#define NO_func2_AI_out_unit_text
#define DEFAULT_VALUE_func2_AI_out_unit UNIT_degC
#define DEFAULT_VALUE_func2_AI_pv_ftime 0
#define DEFAULT_VALUE_func2_lower_range_value -35
#define DEFAULT_VALUE_func2_upper_range_value 250
#include "SIPASTAI2_300.inc"

#define FUNC3_CHANNEL_LIST { 0x0309, [trans_meas_2] }

#define FUNC3_UNIT_LIST					DEF_TRANS_UNIT
#define FUNC_AI_FAIL_SAFE_VALUE			0
#define FUNC_AI_STORING_LAST_SETPOINT	1
#define NO_func3_AI_out_unit_text

#define DEFAULT_VALUE_func3_AI_out_unit UNIT_mS_cm
#define DEFAULT_VALUE_func3_lower_range_value 0
#define DEFAULT_VALUE_func3_upper_range_value 2000

#include "SIPASTAI3_300.inc"

#define FUNC4_CHANNEL_LIST { 0x0409, [trans_temp_temperature_2] }
#define FUNC4_UNIT_LIST					DEF_TRANS_UNIT
#define FUNC_AI_FAIL_SAFE_VALUE			0
#define FUNC_AI_STORING_LAST_SETPOINT	1
#define NO_func4_AI_out_unit_text
#define DEFAULT_VALUE_func4_AI_out_unit UNIT_degC
#define DEFAULT_VALUE_func4_AI_pv_ftime 0
#define DEFAULT_VALUE_func4_lower_range_value -35
#define DEFAULT_VALUE_func4_upper_range_value 250
#include "SIPASTAI4_300.inc"

/*#tbxxxx */
#include "AI1_EHC.DDL"
#include "AI2_EHC.DDL"
#include "AI3_EHC.DDL"
#include "AI4_EHC.DDL"

//**********************************************************************
//    MANUFACTURE SPECIFIC		(Slot 5)
//**********************************************************************

#include "V0Matrix.DDL"
#include "V2Matrix.DDL"
#include "V3Matrix.DDL"
#include "V4Matrix.DDL"
#include "V5Matrix.DDL"
#include "V6Matrix.DDL"
#include "V7Matrix.DDL"
#include "V8Matrix.DDL"
#include "V9Matrix.DDL"
#include "VAMatrix.DDL"
#include "Validate.DDL"

//**********************************************************************
// Menu
//**********************************************************************

#include "MENU_EHC.DDL"

//---------------------------------------------------------------------
//    OnlineWindow: Binre Meldungen
//---------------------------------------------------------------------


//******************************************************************************
//****	Unit relations     *****************************************************
//******************************************************************************


UNIT trans1_unit_relation
{
	trans1_pv_unit:
		trans1_range_begin,
		trans1_range_end,
		trans1_pv_meas_value
		func1_AI_pv_lower_range_value
		func1_AI_pv_upper_range_value
}

UNIT trans2_unit_relation
{
	trans2_pv_unit:
		trans2_range_begin,
		trans2_range_end,
		trans2_pv_meas_value
		func2_AI_pv_lower_range_value
		func2_AI_pv_upper_range_value
}

UNIT trans3_unit_relation
{
	trans3_pv_unit:
		trans3_range_begin,
		trans3_range_end,
		trans3_pv_meas_value
		func3_AI_pv_lower_range_value
		func3_AI_pv_upper_range_value
}

UNIT trans4_unit_relation
{
	trans4_pv_unit:
		trans4_range_begin,
		trans4_range_end,
		trans4_pv_meas_value
		func4_AI_pv_lower_range_value
		func4_AI_pv_upper_range_value
}

UNIT UNITREL_manufact_Unit_Zeropoint_CH1
{
	manufact_Unit_Zeropoint_CH1:
	manufact_Zeropoint_CH1
}

UNIT UNITREL_manufact_Unit_Zeropoint_CH2
{
	manufact_Unit_Zeropoint_CH2:
	manufact_Zeropoint_CH2
}


//******************************************************************************
//****	Method             *****************************************************
//******************************************************************************

#include "CommonParts.ddl"

/************************************************************************************/
/* Set unit to bus                                                                  */
/************************************************************************************/

#define __DDC__set_unit_to_bus_BLOCK_INDEX \
		SLOT 1; INDEX 214;

#define __DDC__set_unit_to_bus_offline_method \
		iassign(func1_AI_out_unit, ivar_value(trans1_pv_unit)); \
		fassign(func1_AI_out_lower_range_value, fvar_value(func1_AI_pv_lower_range_value)); \
		fassign(func1_AI_out_upper_range_value, fvar_value(func1_AI_pv_upper_range_value)); \
		iassign(func2_AI_out_unit, ivar_value(trans2_pv_unit)); \
		fassign(func2_AI_out_lower_range_value, fvar_value(func2_AI_pv_lower_range_value)); \
		fassign(func2_AI_out_upper_range_value, fvar_value(func2_AI_pv_upper_range_value)); \
		iassign(func3_AI_out_unit, ivar_value(trans3_pv_unit)); \
		fassign(func3_AI_out_lower_range_value, fvar_value(func3_AI_pv_lower_range_value)); \
		fassign(func3_AI_out_upper_range_value, fvar_value(func3_AI_pv_upper_range_value)); \
		iassign(func4_AI_out_unit, ivar_value(trans4_pv_unit)); \
		fassign(func4_AI_out_lower_range_value, fvar_value(func4_AI_pv_lower_range_value)); \
		fassign(func4_AI_out_upper_range_value, fvar_value(func4_AI_pv_upper_range_value));

#define __DDC__set_unit_to_bus_online_method \
		ReadCommand(read_func1_AI_out_scale_2); \
		ReadCommand(read_func1_AI_out_scale); \
		ReadCommand(read_func2_AI_out_scale_2); \
		ReadCommand(read_func2_AI_out_scale); \
		ReadCommand(read_func3_AI_out_scale_2); \
		ReadCommand(read_func3_AI_out_scale); \
		ReadCommand(read_func4_AI_out_scale_2); \
		ReadCommand(read_func4_AI_out_scale);

#ifndef _PDM_
	#include "..\..\..\..\..\__DDC__set_unit_to_bus.inc"
#else
	#include "__DDC__set_unit_to_bus.inc"
#endif
/************************************************************************************/

//******************************************************************************
//****	Communication Error Handling  ******************************************
//******************************************************************************

#include "ERROR_EHC.DDL"
