#include "MENU_VH_EHC_Off_PDM.ddl"

//#tb Table_Main_Specialist = Table_Main_Maintenance
MENU Table_Main_Maintenance
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
#ifdef DEVICE_PARAM_PH
	LABEL "Mycom S - CPM 153 P";
#else
	LABEL "Mycom S - CLM 153 LF";
#endif
	ITEMS
	{
		/*#tbneu
		Off_M_Page_diagnosis_general,
		Off_M_Page_diagnosis_physical,
		Off_M_Page_diagnosis_trans,
		Off_M_Page_diagnosis_function,
		Off_M_Page_diagnosis_manufact_specific
		*/
		Off_Page_diagnosis_manufact_specific,
		Off_Page_Profil
	}
}


Off_M_Page_diagnosis_general LIKE MENU Off_Page_diagnosis_general
{
	REDEFINE ITEMS
	{
		phys_tag_desc (READ_ONLY),
		phys_device_man_id,
		phys_device_id,
		phys_device_ser_num,
		phys_software_rev,
		phys_hardware_rev,
		phys_install_date
	
  }
}

Off_M_Page_diagnosis_physical LIKE MENU Off_Page_diagnosis_physical 
{
	REDEFINE ITEMS
	{
		Off_M_Page_diagnosis_phys_standard,
		Off_M_Page_diagnosis_phys_block,
		Off_Page_diagnosis_phys_e_h_param
	}
}

Off_M_Page_diagnosis_phys_standard LIKE MENU Off_Page_diagnosis_phys_standard
{
	REDEFINE ITEMS
	{
		Off_Page_diagnosis_phys_block_object,
		phys_st_rev,
		phys_tag_desc (READ_ONLY),
		phys_strategy (READ_ONLY),
		phys_alert_key (READ_ONLY),
		phys_target_mode (READ_ONLY),
		phys_actual_mode,
		phys_permitted_mode,
		phys_normal_mode
  }
}

Off_M_Page_diagnosis_phys_block LIKE MENU Off_Page_diagnosis_phys_block
{
	REDEFINE ITEMS
	{
		phys_software_rev,
		phys_hardware_rev,
		phys_device_man_id,
		phys_device_id,
		phys_device_ser_num,
		phys_device_certification,
		phys_write_locking (READ_ONLY),
		phys_descriptor (READ_ONLY),
		phys_message (READ_ONLY),
		phys_install_date,
		phys_local_op_enable (READ_ONLY),
		phys_ident_number (READ_ONLY),
		phys_device_configuration,
		phys_init_state (READ_ONLY),
	}
}

MENU Off_M_Page_diagnosis_trans
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[blk_block_object_TRANSDUCER];
	ITEMS
	{
		Off_M_Page_diagnosis_trans1
		Off_M_Page_diagnosis_trans2,
		Off_M_Page_diagnosis_trans3,
		Off_M_Page_diagnosis_trans4
	}
}

/*--------------------------------------*/
MENU Off_M_Page_diagnosis_trans1
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	"TB1";
	ITEMS
	{
		Off_M_Page_diagnosis_trans1_standard,
		Off_M_Page_diagnosis_trans1_block
	}
}

MENU Off_M_Page_diagnosis_trans1_standard
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_phys_standard];
	ITEMS
	{
		Off_Page_diagnosis_trans1_block_object,
		trans1_st_rev,
		trans1_tag_desc (READ_ONLY),
		trans1_strategy (READ_ONLY),
		trans1_alert_key (READ_ONLY),
		trans1_target_mode (READ_ONLY),
		trans1_actual_mode (READ_ONLY),
		trans1_permitted_mode,
		trans1_normal_mode
	}
}

MENU Off_M_Page_diagnosis_trans1_block
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_phys_block];
  ITEMS
  {
		trans1_pv_unit,
		trans1_pv_unit_text,
		trans1_component_name (READ_ONLY),
		//SEPARATOR,
		trans1_active_range,
		trans1_auto_range_on,
		trans1_sampling_rate,
		trans1_number_of_ranges,
		trans1_range_begin (READ_ONLY),
		trans1_range_end (READ_ONLY)
  }
}

/*--------------------------------------*/
MENU Off_M_Page_diagnosis_trans2
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	"TB2";
	ITEMS
	{
		Off_M_Page_diagnosis_trans2_standard,
		Off_M_Page_diagnosis_trans2_block
	}
}

MENU Off_M_Page_diagnosis_trans2_standard
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_phys_standard];
	ITEMS
	{
		Off_Page_diagnosis_trans2_block_object,
		trans2_st_rev,
		trans2_tag_desc (READ_ONLY),
		trans2_strategy (READ_ONLY),
		trans2_alert_key (READ_ONLY),
		trans2_target_mode (READ_ONLY),
		trans2_actual_mode (READ_ONLY),
		trans2_permitted_mode,
		trans2_normal_mode
	}
}

MENU Off_M_Page_diagnosis_trans2_block
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_phys_block];
  ITEMS
  {
		trans2_pv_unit,
		trans2_pv_unit_text,
		trans2_component_name (READ_ONLY),
		//SEPARATOR,
		trans2_active_range,
		trans2_auto_range_on,
		trans2_sampling_rate,
		trans2_number_of_ranges,
		trans2_range_begin (READ_ONLY),
		trans2_range_end (READ_ONLY)
  }
}

/*--------------------------------------*/
MENU Off_M_Page_diagnosis_trans3
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	"TB3";
	ITEMS
	{
		Off_M_Page_diagnosis_trans3_standard,
		Off_M_Page_diagnosis_trans3_block
	}
}

MENU Off_M_Page_diagnosis_trans3_standard
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_phys_standard];
	ITEMS
	{
		Off_Page_diagnosis_trans3_block_object,
		trans3_st_rev,
		trans3_tag_desc (READ_ONLY),
		trans3_strategy (READ_ONLY),
		trans3_alert_key (READ_ONLY),
		trans3_target_mode (READ_ONLY),
		trans3_actual_mode (READ_ONLY),
		trans3_permitted_mode,
		trans3_normal_mode
	}
}

MENU Off_M_Page_diagnosis_trans3_block
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_phys_block];
  ITEMS
  {
		trans3_pv_unit,
		trans3_pv_unit_text,
		trans3_component_name (READ_ONLY),
		//SEPARATOR,
		trans3_active_range,
		trans3_auto_range_on,
		trans3_sampling_rate,
		trans3_number_of_ranges,
		trans3_range_begin (READ_ONLY),
		trans3_range_end (READ_ONLY)
  }
}

/*--------------------------------------*/
MENU Off_M_Page_diagnosis_trans4
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	"TB4";
	ITEMS
	{
		Off_M_Page_diagnosis_trans4_standard,
		Off_M_Page_diagnosis_trans4_block
	}
}

MENU Off_M_Page_diagnosis_trans4_standard
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_phys_standard];
	ITEMS
	{
		Off_Page_diagnosis_trans4_block_object,
		trans4_st_rev,
		trans4_tag_desc (READ_ONLY),
		trans4_strategy (READ_ONLY),
		trans4_alert_key (READ_ONLY),
		trans4_target_mode (READ_ONLY),
		trans4_actual_mode (READ_ONLY),
		trans4_permitted_mode,
		trans4_normal_mode
	}
}

MENU Off_M_Page_diagnosis_trans4_block
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_phys_block];
  ITEMS
  {
		trans4_pv_unit,
		trans4_pv_unit_text,
		trans4_component_name (READ_ONLY),
		//SEPARATOR,
		trans4_active_range,
		trans4_auto_range_on,
		trans4_sampling_rate,
		trans4_number_of_ranges,
		trans4_range_begin (READ_ONLY),
		trans4_range_end (READ_ONLY)
  }
}

/****************************************************/
MENU Off_M_Page_diagnosis_function
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[blk_block_object_FUNCTION];
	ITEMS
	{
		Off_M_Page_diagnosis_function_1
		Off_M_Page_diagnosis_function_2,
		Off_M_Page_diagnosis_function_3,
		Off_M_Page_diagnosis_function_4
	}
}

/*-----------------------------------*/
MENU Off_M_Page_diagnosis_function_1
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	"AI1";
	ITEMS
	{
		Off_M_Page_diagnosis_function1_standard,
		Off_M_Page_diagnosis_function1_block
	}
}

MENU Off_M_Page_diagnosis_function1_standard
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_phys_standard];
	ITEMS
	{
		Off_Page_diagnosis_function1_block_object,
		analog_input1_st_rev,
		analog_input1_tag_desc (READ_ONLY),
		analog_input1_strategy (READ_ONLY),
		analog_input1_alert_key (READ_ONLY),
		analog_input1_target_mode (READ_ONLY),
		analog_input1_permitted_mode,
		analog_input1_normal_mode
  }
}

MENU Off_M_Page_diagnosis_function1_block
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_phys_block];
	ITEMS
	{
		analog_input1_batch_id (READ_ONLY),
		analog_input1_batch_unit (READ_ONLY),
		analog_input1_batch_operation (READ_ONLY), 
		analog_input1_batch_phase (READ_ONLY),
		analog_input1_out_unit (READ_ONLY), 
		analog_input1_pv_upper_range_value (READ_ONLY), 
		analog_input1_pv_lower_range_value (READ_ONLY),
		analog_input1_out_upper_range_value (READ_ONLY),	
		analog_input1_out_lower_range_value (READ_ONLY),
		analog_input1_out_decimal_point (READ_ONLY),
		analog_input1_lin_type (READ_ONLY),
		analog_input1_channel (READ_ONLY),
		analog_input1_pv_ftime (READ_ONLY),
		Off_M_Page_diagnosis_function1_block_limit_check,
	}
}

MENU Off_M_Page_diagnosis_function1_block_limit_check
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_block_limit_check];
  ITEMS
  {
		analog_input1_alarm_hys (READ_ONLY),
		analog_input1_hi_hi_lim (READ_ONLY),
		analog_input1_hi_lim (READ_ONLY),
		analog_input1_lo_lim (READ_ONLY),
		analog_input1_lo_lo_lim (READ_ONLY)
  }
}

/*-----------------------------------*/
MENU Off_M_Page_diagnosis_function_2
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	"AI2";
	ITEMS
	{
		Off_M_Page_diagnosis_function2_standard,
		Off_M_Page_diagnosis_function2_block
	}
}

MENU Off_M_Page_diagnosis_function2_standard
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_phys_standard];
	ITEMS
	{
		Off_Page_diagnosis_function2_block_object,
		analog_input2_st_rev,
		analog_input2_tag_desc (READ_ONLY),
		analog_input2_strategy (READ_ONLY),
		analog_input2_alert_key (READ_ONLY),
		analog_input2_target_mode (READ_ONLY),
		analog_input2_permitted_mode,
		analog_input2_normal_mode
  }
}

MENU Off_M_Page_diagnosis_function2_block
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_phys_block];
	ITEMS
	{
		analog_input2_batch_id (READ_ONLY),
		analog_input2_batch_unit (READ_ONLY),
		analog_input2_batch_operation (READ_ONLY), 
		analog_input2_batch_phase (READ_ONLY),
		analog_input2_out_unit (READ_ONLY), 
		analog_input2_pv_upper_range_value (READ_ONLY), 
		analog_input2_pv_lower_range_value (READ_ONLY),
		analog_input2_out_upper_range_value (READ_ONLY),	
		analog_input2_out_lower_range_value (READ_ONLY),
		analog_input2_out_decimal_point (READ_ONLY),
		analog_input2_lin_type (READ_ONLY),
		analog_input2_channel (READ_ONLY),
		analog_input2_pv_ftime (READ_ONLY),
		Off_M_Page_diagnosis_function2_block_limit_check,
	}
}

MENU Off_M_Page_diagnosis_function2_block_limit_check
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_block_limit_check];
  ITEMS
  {
		analog_input2_alarm_hys (READ_ONLY),
		analog_input2_hi_hi_lim (READ_ONLY),
		analog_input2_hi_lim (READ_ONLY),
		analog_input2_lo_lim (READ_ONLY),
		analog_input2_lo_lo_lim (READ_ONLY)
  }
}

/*-----------------------------------*/
MENU Off_M_Page_diagnosis_function_3
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	"AI3";
	ITEMS
	{
		Off_M_Page_diagnosis_function3_standard,
		Off_M_Page_diagnosis_function3_block
	}
}

MENU Off_M_Page_diagnosis_function3_standard
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_phys_standard];
	ITEMS
	{
		Off_Page_diagnosis_function3_block_object,
		analog_input3_st_rev,
		analog_input3_tag_desc (READ_ONLY),
		analog_input3_strategy (READ_ONLY),
		analog_input3_alert_key (READ_ONLY),
		analog_input3_target_mode (READ_ONLY),
		analog_input3_permitted_mode,
		analog_input3_normal_mode
  }
}

MENU Off_M_Page_diagnosis_function3_block
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_phys_block];
	ITEMS
	{
		analog_input3_batch_id (READ_ONLY),
		analog_input3_batch_unit (READ_ONLY),
		analog_input3_batch_operation (READ_ONLY), 
		analog_input3_batch_phase (READ_ONLY),
		analog_input3_out_unit (READ_ONLY), 
		analog_input3_pv_upper_range_value (READ_ONLY), 
		analog_input3_pv_lower_range_value (READ_ONLY),
		analog_input3_out_upper_range_value (READ_ONLY),	
		analog_input3_out_lower_range_value (READ_ONLY),
		analog_input3_out_decimal_point (READ_ONLY),
		analog_input3_lin_type (READ_ONLY),
		analog_input3_channel (READ_ONLY),
		analog_input3_pv_ftime (READ_ONLY),
		Off_M_Page_diagnosis_function3_block_limit_check,
	}
}

MENU Off_M_Page_diagnosis_function3_block_limit_check
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_block_limit_check];
  ITEMS
  {
		analog_input3_alarm_hys (READ_ONLY),
		analog_input3_hi_hi_lim (READ_ONLY),
		analog_input3_hi_lim (READ_ONLY),
		analog_input3_lo_lim (READ_ONLY),
		analog_input3_lo_lo_lim (READ_ONLY)
  }
}

/*-----------------------------------*/
MENU Off_M_Page_diagnosis_function_4
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	"AI4";
	ITEMS
	{
		Off_M_Page_diagnosis_function4_standard,
		Off_M_Page_diagnosis_function4_block
	}
}

MENU Off_M_Page_diagnosis_function4_standard
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_phys_standard];
	ITEMS
	{
		Off_Page_diagnosis_function4_block_object,
		analog_input4_st_rev,
		analog_input4_tag_desc (READ_ONLY),
		analog_input4_strategy (READ_ONLY),
		analog_input4_alert_key (READ_ONLY),
		analog_input4_target_mode (READ_ONLY),
		analog_input4_permitted_mode,
		analog_input4_normal_mode
  }
}

MENU Off_M_Page_diagnosis_function4_block
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
	LABEL	[lbl_Page_diagnosis_phys_block];
	ITEMS
	{
		analog_input4_batch_id (READ_ONLY),
		analog_input4_batch_unit (READ_ONLY),
		analog_input4_batch_operation (READ_ONLY), 
		analog_input4_batch_phase (READ_ONLY),
		analog_input4_out_unit (READ_ONLY), 
		analog_input4_pv_upper_range_value (READ_ONLY), 
		analog_input4_pv_lower_range_value (READ_ONLY),
		analog_input4_out_upper_range_value (READ_ONLY),	
		analog_input4_out_lower_range_value (READ_ONLY),
		analog_input4_out_decimal_point (READ_ONLY),
		analog_input4_lin_type (READ_ONLY),
		analog_input4_channel (READ_ONLY),
		analog_input4_pv_ftime (READ_ONLY),
		Off_M_Page_diagnosis_function4_block_limit_check,
	}
}

MENU Off_M_Page_diagnosis_function4_block_limit_check
{
	#ifndef _PDM_
	ACCESS OFFLINE;
	#endif
  LABEL	[lbl_Page_diagnosis_block_limit_check];
  ITEMS
  {
		analog_input4_alarm_hys (READ_ONLY),
		analog_input4_hi_hi_lim (READ_ONLY),
		analog_input4_hi_lim (READ_ONLY),
		analog_input4_lo_lim (READ_ONLY),
		analog_input4_lo_lo_lim (READ_ONLY)
  }
}

//###### simulation for offline ########################
Page_Simulation_offline LIKE MENU Page_Simulation
{
	 
	#ifndef _PDM_
	REDEFINE	ACCESS OFFLINE;
	#endif
	REDEFINE ITEMS
	{
		Page_Simulation_ai1_offline,
		Page_Simulation_ai2_offline,
		Page_Simulation_ai3_offline,
		Page_Simulation_ai4_offline
	}
}

Page_Simulation_ai1_offline LIKE MENU Page_Simulation_ai1
{
	#ifndef _PDM_
	REDEFINE ACCESS OFFLINE;
	#endif
	REDEFINE ITEMS
	{
		refSimulationAI1,
		analog_input1_simulation_enabled (READ_ONLY),
		analog_input1_simulate_status_quality (READ_ONLY),
		analog_input1_simulate_status_limit (READ_ONLY),
		analog_input1_simulate_value (READ_ONLY)
	}
}

Page_Simulation_ai2_offline LIKE MENU Page_Simulation_ai2
{
	#ifndef _PDM_
	REDEFINE ACCESS OFFLINE;
	#endif
	REDEFINE ITEMS
	{
		refSimulationAI2,
		analog_input2_simulation_enabled (READ_ONLY),
		analog_input2_simulate_status_quality (READ_ONLY),
		analog_input2_simulate_status_limit (READ_ONLY),
		analog_input2_simulate_value (READ_ONLY)
	}
}

Page_Simulation_ai3_offline LIKE MENU Page_Simulation_ai3
{
	#ifndef _PDM_
	REDEFINE ACCESS OFFLINE;
	#endif
	REDEFINE ITEMS
	{
		refSimulationAI3,
		analog_input3_simulation_enabled (READ_ONLY),
		analog_input3_simulate_status_quality (READ_ONLY),
		analog_input3_simulate_status_limit (READ_ONLY),
		analog_input3_simulate_value (READ_ONLY)
	}
}

Page_Simulation_ai4_offline LIKE MENU Page_Simulation_ai4
{
	#ifndef _PDM_
	REDEFINE ACCESS OFFLINE;
	#endif
	REDEFINE ITEMS
	{
		refSimulationAI4,
		analog_input4_simulation_enabled (READ_ONLY),
		analog_input4_simulate_status_quality (READ_ONLY),
		analog_input4_simulate_status_limit (READ_ONLY),
		analog_input4_simulate_value (READ_ONLY)
	}
}

VARIABLE refSimulationAI1
{
	LABEL "Simulation";
	CLASS LOCAL ;
	HANDLING READ ;
	TYPE ENUMERATED 
	{
		DEFAULT_VALUE 0;
		{ 0, [refSimulationAI1] }
	}
}

refSimulationAI2 LIKE VARIABLE refSimulationAI1
{
	REDEFINE TYPE ENUMERATED 
	{
		DEFAULT_VALUE 0;
		{ 0, [refSimulationAI2] }
	}
}

refSimulationAI3 LIKE VARIABLE refSimulationAI1
{
	REDEFINE TYPE ENUMERATED 
	{
		DEFAULT_VALUE 0;
		{ 0, [refSimulationAI3] }
	}
}

refSimulationAI4 LIKE VARIABLE refSimulationAI1
{
	REDEFINE TYPE ENUMERATED 
	{
		DEFAULT_VALUE 0;
		{ 0, [refSimulationAI4] }
	}
}

VARIABLE refTopcal
{
	LABEL "TopCal/TopClean";
	CLASS LOCAL ;
	HANDLING READ ;
	TYPE ENUMERATED 
	{
		DEFAULT_VALUE 0;
		{ 0, [refTopcal] }
	}
}

VARIABLE refChemoclean
{
	LABEL "ChemoClean";
	CLASS LOCAL ;
	HANDLING READ ;
	TYPE ENUMERATED 
	{
		DEFAULT_VALUE 0;
		{ 0, [refChemoclean] }
	}
}

VARIABLE refController
{
	LABEL "Controller|de|Regler";
	CLASS LOCAL ;
	HANDLING READ ;
	TYPE ENUMERATED 
	{
		DEFAULT_VALUE 0;
		{ 0, [refController] }
	}
}

VARIABLE refValidtate
{
	LABEL [lbl_Page_diagnosis_Validate];
	CLASS LOCAL ;
	HANDLING READ ;
	TYPE ENUMERATED 
	{
		DEFAULT_VALUE 0;
		{ 0, [refValidtate] }
	}
}

VARIABLE refSet_Unit_To_Bus
{
	LABEL [lbl_method_Set_Unit_To_Bus];
	CLASS LOCAL ;
	HANDLING READ ;
	TYPE ENUMERATED 
	{
		DEFAULT_VALUE 0;
		{ 0, [refSet_Unit_To_Bus] }
	}
}

VARIABLE refReset
{
	LABEL [lbl_manufact_Reset];
	CLASS LOCAL ;
	HANDLING READ ;
	TYPE ENUMERATED 
	{
		DEFAULT_VALUE 0;
		{ 0, [refReset] }
	}
}


Off_Tab_s_ident LIKE MENU Tab_s_ident
{
	REDEFINE ITEMS
	{
		Tab_s_ident_opunit,
		Off_Tab_s_ident_device

#ifdef PHYS_ADDITIONAL_GROUP_SPECIALIST
		,
		PHYS_ADDITIONAL_GROUP_SPECIALIST
#endif
	}
}

Off_Tab_s_ident_device LIKE MENU Tab_s_ident_device
{
	REDEFINE ITEMS
	{
		phys_device_man_id,
		phys_device_id,
		phys_device_ser_num,
		phys_software_rev,
		phys_hardware_rev,
		phys_blk_profile_rev,
		phys_st_rev,
		phys_ident_number (READ_ONLY),
		phys_install_date
#ifdef PHYS_ADDITIONAL_PARAMETER
		,
		PHYS_ADDITIONAL_PARAMETER
#endif
	}
}