//**********************************************************************
//    Physical Block		(Slot 1)
//**********************************************************************

BLOCK physical_block
{
	TYPE	PHYSICAL;
	NUMBER	1;
}

//----------------------------------------------------------------------
//  BLOCK_OBJECT: 12 x phys_blk...
//----------------------------------------------------------------------

VARIABLE phys_blk_reserve
{
	LABEL		[blk_reserved];
	HELP		[blk_reserved_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

VARIABLE phys_blk_object
{
	LABEL		[blk_block_object];
	HELP		[blk_block_object_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	1,	[blk_block_object_PHYSICAL]	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_parent_class
{
	LABEL		[blk_parent_class];
	HELP		[phys_blk_parent_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		{	5,	[phys_blk_parent_class_ANALYSER]	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_class
{
	LABEL		[blk_class];
	HELP		[phys_blk_class_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	250;
		{	250,	[not_used]		}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_dd_reference
{
	LABEL		[blk_dd_reference];
	HELP		[blk_dd_reference_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4);
	HANDLING	READ;
}

VARIABLE phys_blk_dd_rev
{
	LABEL		[blk_dd_rev];
	HELP		[blk_dd_rev_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2);
	HANDLING	READ;
}

VARIABLE phys_blk_profile
{
	LABEL		[blk_profile];
	HELP		[blk_profile_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0x4002;
		{ 0x4001,	[blk_profile_PA_COMPACT_A]	},
		{ 0x4002,	[blk_profile_PA_COMPACT_B]	},
		{ 0x4081,	[blk_profile_PA_SIMPLE_A]	},
		{ 0x4082,	[blk_profile_PA_SIMPLE_B]	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_profile_rev
{
	LABEL		[blk_profile_rev];
	HELP		[blk_profile_rev_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0300;
		{	0x0300,	"3.0"	}
	}
	HANDLING	READ;
}

VARIABLE phys_blk_execution_time
{
	LABEL		[blk_execution_time];
	HELP		[blk_execution_time_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1);
	HANDLING	READ;
}

VARIABLE phys_blk_num_parameters
{
	LABEL		[blk_num_parameters];
	HELP		[blk_num_parameters_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE phys_blk_index_view_1
{
	LABEL		[blk_index_view_1];
	HELP		[blk_index_view_1_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2);
	HANDLING	READ;
}

VARIABLE phys_blk_num_view_lists
{
	LABEL		[blk_num_view_lists];
	HELP		[blk_num_view_lists_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1);
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_st_rev
{
	LABEL		[st_rev];
	HELP		[st_rev_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_tag_desc
{
	LABEL		[tag_desc];		
	HELP		[tag_desc_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32)
	{
		DEFAULT_VALUE	"------";
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

VARIABLE phys_strategy
{
	LABEL		[strategy];		
	HELP		[strategy_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0; 
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

VARIABLE phys_alert_key
{
	LABEL		[alert_key];		
	HELP		[alert_key_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	0; 
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

VARIABLE phys_target_mode
{
	LABEL		[target_mode];		
	HELP		[target_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]	}
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------
//  MODE_BLK: phys_actual_mode, phys_permitted_mode, phys_normal_mode
//----------------------------------------------------------------------

VARIABLE phys_actual_mode
{
	LABEL		[actual_mode];		
	HELP		[actual_mode_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		{	0x08,	[mode_AUTO]	}
	}
	HANDLING	READ;
}

VARIABLE phys_permitted_mode
{
	LABEL		[permitted_mode];		
	HELP		[permitted_mode_help];
	CLASS		CONTAINED;
	TYPE		BIT_ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08; 
		{	0x08,	[mode_AUTO]		},
		{	0x80,	[mode_OUT_OF_SERVICE]	}
	}
	HANDLING	READ;
}

VARIABLE phys_normal_mode
{
	LABEL		[normal_mode];		
	HELP		[normal_mode_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x08; 
		{	0x08,	[mode_AUTO]	}
	}
	HANDLING	READ;
}

//-----------------------------------------------------------------------------------
//  ALARM_SUM:	phys_current_state_alarm_sum, phys_unacknowledged_state_alarm_sum,
//				phys_unreported_state_alarm_sum, phys_disabled_state_alarm_sum
//-----------------------------------------------------------------------------------

VARIABLE phys_current_state_alarm_sum
{
	LABEL		[current_state_alarm_sum];		
	HELP		[current_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000; 
//#tb		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_unacknowledged_state_alarm_sum
{
	LABEL		[unacknowledged_state_alarm_sum];		
	HELP		[unacknowledged_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000; 
//#tb		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_unreported_state_alarm_sum
{
	LABEL		[unreported_state_alarm_sum];		
	HELP		[unreported_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000; 
//#tb		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

VARIABLE phys_disabled_state_alarm_sum
{
	LABEL		[disabled_state_alarm_sum];		
	HELP		[disabled_state_alarm_sum_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		DEFAULT_VALUE	0x0000; 
//#tb		{	0x0000,	[limit_state_NO_ALARM]	},
		{	0x8000,	[limit_state_ST_REV]	}
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_software_rev
{
	LABEL		[phys_software_revision];
	HELP		[phys_software_revision_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_hardware_rev
{
  LABEL		[phys_hardware_revision];
  HELP		[phys_hardware_revision_help];
  CLASS		CONTAINED;
  TYPE		ASCII (16);
  HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_device_man_id
{
	LABEL		[phys_device_man_id];
	HELP		[phys_device_man_id_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	17; 
		{ 0,		[unknown]},
		{ 17,		"Endress+Hauser"}
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_device_id
{
	LABEL	[phys_device_type];
	CLASS	CONTAINED;
	TYPE	ASCII(16)
	{
		DEFAULT_VALUE	DEF_device_id_PB;
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_device_ser_num
{
	LABEL		[phys_serial_num];
	HELP		[phys_device_ser_num_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE	"";
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

#define DIA_HW_ELECTR			0x01000080
#define DIA_MEM_CHKSUM			0x10000080
#define DIA_CONF_INVAL			0x00040080
#define EXTENSION_AVAILABLE		0x00000080
#define DIA_MEASUREMENT			0x20000080
#define DIA_HW_MECH				0x02000080
#define DIA_SUPPLY				0x00020080
#define DIA_MAINTENANCE			0x00200080

VARIABLE phys_diagnosis
{
	LABEL		[phys_diagnosis];
	HELP		[phys_diagnosis_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (4)
	{
		DEFAULT_VALUE	EXTENSION_AVAILABLE; 
		{	DIA_HW_ELECTR,		[dia_HW_ELECTR],			[dia_HW_ELECTR_help]	},
		{	DIA_MEM_CHKSUM,		[dia_MEM_CHKSUM],			[dia_MEM_CHKSUM_help]	},
		{	DIA_CONF_INVAL,		[dia_CONF_INVAL],			[dia_CONF_INVAL_help]	},
		{	DIA_MEASUREMENT,	[dia_MEASUREMENT],			[dia_MEASUREMENT_help]	},
		{	DIA_HW_MECH,		[dia_HW_MECH],				[dia_HW_MECH_help]	},
		{	DIA_SUPPLY,			[dia_SUPPLY],				[dia_SUPPLY_help]	},
		{	DIA_MAINTENANCE,	[dia_MAINTENANCE],			[dia_MAINTENANCE_help]	},
		{	EXTENSION_AVAILABLE,[dia_EXTENSION_AVAILABLE],	[dia_EXTENSION_AVAILABLE_help]	}
	}
	HANDLING	READ;
	#ifdef _PDM_
		STYLE    "MULTILINE 25 8"; 
	#endif
}

//----------------------------------------------------------------------

#define DIA_EXT_BIT_56	 0x01
#define DIA_EXT_BIT_57	 0x02
#define DIA_EXT_BIT_58	 0x04
#define DIA_EXT_BIT_59	 0x08
#define DIA_EXT_BIT_60	 0x10
#define DIA_EXT_BIT_61	 0x20
#define DIA_EXT_BIT_62	 0x40
#define DIA_EXT_BIT_63	 0x80

VARIABLE phys_diagnosis_ext_BYTE_1
{
	LABEL		[lbl_phys_diagnosis_ext_BYTE_1];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED
	{
#ifdef DEVICE_PARAM_PH
		{DIA_EXT_BIT_56 ,[lbl_DIA_EXT_BIT_56]	,	"E001"},
		{DIA_EXT_BIT_57 ,[lbl_DIA_EXT_BIT_57]	,	"E002,E017"},
		{DIA_EXT_BIT_58 ,[lbl_DIA_EXT_BIT_58]	,	"E003"},
		{DIA_EXT_BIT_59	,[lbl_DIA_EXT_BIT_59]	,	"E004,E005"},
		{DIA_EXT_BIT_60	,[lbl_DIA_EXT_BIT_60]	,	"E006,E007	"},
		{DIA_EXT_BIT_61	,[lbl_DIA_EXT_BIT_61]	,	"E008,E009,E010,E011"},
		{DIA_EXT_BIT_62	,[lbl_DIA_EXT_BIT_62]	,	"E012"},
		{DIA_EXT_BIT_63	,[lbl_DIA_EXT_BIT_63]	,	"E013,E014"}
#endif
#ifdef DEVICE_PARAM_LF
		{DIA_EXT_BIT_56 ,[lbl_DIA_EXT_BIT_56]	,	"E001"},
		{DIA_EXT_BIT_57 ,[lbl_DIA_EXT_BIT_57]	,	"E002"},
		{DIA_EXT_BIT_58 ,[lbl_DIA_EXT_BIT_58]	,	"E003"},
		{DIA_EXT_BIT_59	,[lbl_DIA_EXT_BIT_59]	,	"E004"},
		{DIA_EXT_BIT_60	,[lbl_DIA_EXT_BIT_60]	,	"E006,E007	"},
		{DIA_EXT_BIT_61	,[lbl_DIA_EXT_BIT_61]	,	"E008,E009,E010,E011"}
#endif
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

#define DIA_EXT_BIT_64	 0x01
#define DIA_EXT_BIT_65	 0x02
#define DIA_EXT_BIT_66	 0x04
#define DIA_EXT_BIT_67	 0x08
#define DIA_EXT_BIT_68	 0x10
#define DIA_EXT_BIT_69	 0x20
#define DIA_EXT_BIT_70	 0x40
#define DIA_EXT_BIT_71	 0x80


VARIABLE phys_diagnosis_ext_BYTE_2
{
	LABEL		[lbl_phys_diagnosis_ext_BYTE_2];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED
	{
#ifdef DEVICE_PARAM_PH
		{DIA_EXT_BIT_64	,[lbl_DIA_EXT_BIT_64]	,			"E015,E016"},
		{DIA_EXT_BIT_65	,[lbl_DIA_EXT_BIT_65]	,			"E019"},
		{DIA_EXT_BIT_66	,[lbl_DIA_EXT_BIT_66]	,			"E024"},
		{DIA_EXT_BIT_67	,[lbl_DIA_EXT_BIT_67]	,			"E027"},
		{DIA_EXT_BIT_68	,[lbl_DIA_EXT_BIT_68]	,			"E030,E031"},
		{DIA_EXT_BIT_69	,[lbl_DIA_EXT_BIT_69]	,			"E032,E033,E034,E035,E036,E037"},
		{DIA_EXT_BIT_70	,[lbl_DIA_EXT_BIT_70]	,			"E045"},
		{DIA_EXT_BIT_71	,[lbl_DIA_EXT_BIT_71]	,			"E053"}
#endif
#ifdef DEVICE_PARAM_LF
		{DIA_EXT_BIT_65	,[lbl_DIA_EXT_BIT_65]	,			"E019"},
		{DIA_EXT_BIT_68	,[lbl_DIA_EXT_BIT_68_LF]	,			"E025,E026"},
		{DIA_EXT_BIT_69 	,[lbl_DIA_EXT_BIT_69_LF]	,			"E034,E035,E036,E037"},
		{DIA_EXT_BIT_70	,[lbl_DIA_EXT_BIT_70_LF]	,			"E046,E047,E048,E049"},
		{DIA_EXT_BIT_71	,[lbl_DIA_EXT_BIT_71]	,			"E053"}
#endif
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

#define DIA_EXT_BIT_72	 0x01
#define DIA_EXT_BIT_73	 0x02
#define DIA_EXT_BIT_74	 0x04
#define DIA_EXT_BIT_75	 0x08
#define DIA_EXT_BIT_76	 0x10
#define DIA_EXT_BIT_77	 0x20


VARIABLE phys_diagnosis_ext_BYTE_3
{
	LABEL		[lbl_phys_diagnosis_ext_BYTE_3];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED
	{
#ifdef DEVICE_PARAM_PH
		{DIA_EXT_BIT_72	,[lbl_DIA_EXT_BIT_72]	,		"E055,E056,E057,E058"},
		{DIA_EXT_BIT_73	,[lbl_DIA_EXT_BIT_73]	,		"E059,E060,E061,E062"},
		{DIA_EXT_BIT_74	,[lbl_DIA_EXT_BIT_74]	,		"E073,E074,E075,E076"},
		{DIA_EXT_BIT_75	,[lbl_DIA_EXT_BIT_75]	,		"E116,E117"},
		{DIA_EXT_BIT_76	,[lbl_DIA_EXT_BIT_76]	,		"E164,E165"},
		{DIA_EXT_BIT_77	,[lbl_DIA_EXT_BIT_77]	,		"E166,E167"}
#endif
#ifdef DEVICE_PARAM_LF
		{DIA_EXT_BIT_72	,[lbl_DIA_EXT_BIT_72_LF]	,		"E055,E056,E057,E058"},
		{DIA_EXT_BIT_73	,[lbl_DIA_EXT_BIT_73]	,		"E059,E060,E061,E062"},
		{DIA_EXT_BIT_74	,[lbl_DIA_EXT_BIT_74_LF]	,		"E074,E077"},
		{DIA_EXT_BIT_75	,[lbl_DIA_EXT_BIT_75]	,		"E116,E117"},
		{DIA_EXT_BIT_76	,[lbl_DIA_EXT_BIT_76_LF]	,		"E072,E073"},
		{DIA_EXT_BIT_77	,[lbl_DIA_EXT_BIT_77_LF]	,		"E075,E076,E078,E079"}
#endif
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

#define DIA_EXT_BIT_80	 0x01
#define DIA_EXT_BIT_81	 0x02
#define DIA_EXT_BIT_82	 0x04
#define DIA_EXT_BIT_83	 0x08
#define DIA_EXT_BIT_84	 0x10
#define DIA_EXT_BIT_85	 0x20
#define DIA_EXT_BIT_86	 0x40
#define DIA_EXT_BIT_87	 0x80

VARIABLE phys_diagnosis_ext_BYTE_4
{
	LABEL		[lbl_phys_diagnosis_ext_BYTE_4];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED
	{
#ifdef DEVICE_PARAM_PH
		{DIA_EXT_BIT_80	,[lbl_DIA_EXT_BIT_80]	,			"E038"},
		{DIA_EXT_BIT_81	,[lbl_DIA_EXT_BIT_81]	,			"E040,E041"},
		{DIA_EXT_BIT_82	,[lbl_DIA_EXT_BIT_82]	,			"E043,E048"},
		{DIA_EXT_BIT_83	,[lbl_DIA_EXT_BIT_83]	,			"E044,E049	"},
		{DIA_EXT_BIT_84	,[lbl_DIA_EXT_BIT_84]	,			"E050,E051,E052"},
		{DIA_EXT_BIT_85	,[lbl_DIA_EXT_BIT_85]	,			"E054"},
		{DIA_EXT_BIT_86	,[lbl_DIA_EXT_BIT_86]	,			"E067,E068,E069,E070,E071"},
		{DIA_EXT_BIT_87	,[lbl_DIA_EXT_BIT_87]	,			"E152,E153"}
#endif
#ifdef DEVICE_PARAM_LF
		{DIA_EXT_BIT_80	,[lbl_DIA_EXT_BIT_80_LF]	,			"E038"},
		{DIA_EXT_BIT_85	,[lbl_DIA_EXT_BIT_85]	,			"E054"},
		{DIA_EXT_BIT_86	,[lbl_DIA_EXT_BIT_86]	,			"E067,E068,E069,E070,E071"},
		{DIA_EXT_BIT_87	,[lbl_DIA_EXT_BIT_87]	,			"E152,E153"}
#endif
	}
	HANDLING	READ;
}
//----------------------------------------------------------------------

#define DIA_EXT_BIT_88	 0x01
#define DIA_EXT_BIT_89	 0x02
#define DIA_EXT_BIT_90	 0x04

VARIABLE phys_diagnosis_ext_BYTE_5
{
	LABEL		[lbl_phys_diagnosis_ext_BYTE_5];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED
	{
#ifdef DEVICE_PARAM_PH
		{DIA_EXT_BIT_88	,[lbl_DIA_EXT_BIT_88]	,	"E168,E169"},
#endif
#ifdef DEVICE_PARAM_LF
		{DIA_EXT_BIT_88	,[lbl_DIA_EXT_BIT_88_LF]	,	"E154,E155,E156,E157"},
#endif
		{DIA_EXT_BIT_89	,[lbl_DIA_EXT_BIT_89]	,	"E171,E172"},
		{DIA_EXT_BIT_90	,[lbl_DIA_EXT_BIT_90]	,	"E173,E174"}
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

#define DIA_EXT_BIT_102	 0x40
#define DIA_EXT_BIT_103	 0x80

VARIABLE phys_diagnosis_ext_BYTE_6
{
	LABEL		[lbl_phys_diagnosis_ext_BYTE_6];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED
	{
#ifdef DEVICE_PARAM_PH
		{DIA_EXT_BIT_102,[lbl_DIA_EXT_BIT_102],					"E090"},
#endif
		{DIA_EXT_BIT_103,[lbl_DIA_EXT_BIT_103],					"E100"}
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_device_certification
{
	LABEL		[phys_device_certification];
	HELP		[phys_device_certification_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32);
/*
	{
		DEFAULT_VALUE CERTIFICATE_DEVICE;
	}
*/
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_write_locking
{
	LABEL		[phys_write_locking];
	HELP		[phys_write_locking_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(2)
	{ 
		LOCKING_LIST
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

VARIABLE phys_factory_reset
{
	LABEL		[phys_factory_reset];
	HELP		[phys_factory_reset_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	0;
		{ 0x0000,	[no_function]				},
		{ 0x0001,	[factory_reset_PARAMS]		},
		{ 0x8000,	[lbl_factoryResetCalibData]	},
		{ 0x8001,	[lbl_factoryResetParamData]	},
		{ 2506,		[phys_device_reset_cmd]		},
		{ 2712,		[factory_reset_ADDRESS]		}
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

VARIABLE phys_descriptor
{
	LABEL		[phys_descriptor];
	HELP		[phys_descriptor_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32);
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

VARIABLE phys_message
{
	LABEL		[phys_message];
	HELP		[phys_message_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32);
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

VARIABLE phys_install_date
{
	LABEL		[phys_install_date];
	HELP		[phys_install_date_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE "01.01.2002";
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_local_op_enable
{
	LABEL		[lbl_phys_local_op_enable];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{ 0,	[disabled]	},
		{ 1,	[enabled]	}
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

VARIABLE phys_ident_number
{
	LABEL		[phys_ident_number];
	HELP		[phys_ident_number_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	1;
		{	0,		[phys_ident_number_ANALYSER]				},
		{	1,		[lbl_phys_ident_number_spec_P3]				},
		{	2,		[lbl_phys_ident_number_spec_P2]				}
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

VARIABLE phys_HW_write_protection
{
	LABEL		[lbl_phys_HW_write_protection];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{ 0,	[not_write_prot]	},
		{ 1,	[write_prot]		}
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_device_configuration
{
	LABEL		[phys_analysis_device_configuration];
	HELP		[phys_analysis_device_configuration_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32)
	{
		DEFAULT_VALUE	"-----";
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_init_state
{
	LABEL		[phys_analysis_init_state];
	HELP		[phys_analysis_init_state_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED
	{
		DEFAULT_VALUE STATUS_RUN;
		{ STATUS_RUN,			[status_run]		},
		{ STATUS_MAINTENANCE,	[status_maintenance]}
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

VARIABLE phys_device_state
{
	LABEL		[phys_analysis_device_state];
	HELP		[phys_analysis_device_state_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED
	{
		DEFAULT_VALUE STATUS_RUN;
		{ STATUS_RUN,			[status_run]		},
		{ STATUS_MAINTENANCE,	[status_maintenance]}
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

#define NAMUR_FAILURE			0x0001
#define NAMUR_MAINTENANCE		0x0002
#define NAMUR_FUNCTION_CHECK	0x0004
#define LIMITS					0x0008

VARIABLE phys_global_status
{
	LABEL		[lbl_phys_global_status];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		BIT_ENUMERATED (2)
	{
		{NAMUR_FAILURE			,[lbl_NAMUR_FAILURE]		,			"---"},
		{NAMUR_MAINTENANCE		,[lbl_NAMUR_MAINTENANCE]	,			"---"},
		{NAMUR_FUNCTION_CHECK	,[lbl_NAMUR_FUNCTION_CHECK]	,			"---"},
		{LIMITS					,[lbl_phys_global_status_limits],		"---"}

	}
	HANDLING	READ;
}

//---------------------------------------------------------------------
//    Physical Block: Manufacturer specific parameters
//---------------------------------------------------------------------

VARIABLE phys_ehc_actual_error
{
	LABEL		[lbl_phys_ehc_actual_error];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED(2)
	{
		DEFAULT_VALUE	0;
		{0, ""},

		#ifdef DEVICE_PARAM_PH
			{1,	[lbl_CPM_E001]	,[hlp_CPM_E001]},
			{2, [lbl_CPM_E002]	,[hlp_CPM_E002]},
			{3, [lbl_CPM_E003]	,[hlp_CPM_E003]},
			{4, [lbl_CPM_E004]	,[hlp_CPM_E004]},
			{5, [lbl_CPM_E005]	,[hlp_CPM_E005]},
			{6, [lbl_CPM_E006]	,[hlp_CPM_E006]},
			{7, [lbl_CPM_E007]	,[hlp_CPM_E007]},
			{8, [lbl_CPM_E008]	,[hlp_CPM_E008]},
			{9, [lbl_CPM_E009]	,[hlp_CPM_E009]},
			{10, [lbl_CPM_E010]	,[hlp_CPM_E010]},
			{11, [lbl_CPM_E011]	,[hlp_CPM_E011]},
			{12, [lbl_CPM_E012]	,[hlp_CPM_E012]},
			{13, [lbl_CPM_E013]	,[hlp_CPM_E013]},
			{14, [lbl_CPM_E014]	,[hlp_CPM_E014]},
			{15, [lbl_CPM_E015]	,[hlp_CPM_E015]},
			{16, [lbl_CPM_E016]	,[hlp_CPM_E016]},
			{17, [lbl_CPM_E017]	,[hlp_CPM_E017]},
			{19, [lbl_CPM_E019]	,[hlp_CPM_E019]},
			{24, [lbl_CPM_E024]	,[hlp_CPM_E024]},
			{25, [lbl_CPM_E025]	,[hlp_CPM_E025]},
			{27, [lbl_CPM_E027]	,[hlp_CPM_E027]},
			{28, [lbl_CPM_E028]	,[hlp_CPM_E028]},
			{30, [lbl_CPM_E030]	,[hlp_CPM_E030]},
			{31, [lbl_CPM_E031]	,[hlp_CPM_E031]},
			{32, [lbl_CPM_E032]	,[hlp_CPM_E032]},
			{33, [lbl_CPM_E033]	,[hlp_CPM_E033]},
			{34, [lbl_CPM_E034]	,[hlp_CPM_E034]},
			{35, [lbl_CPM_E035]	,[hlp_CPM_E035]},
			{36, [lbl_CPM_E036]	,[hlp_CPM_E036]},
			{37, [lbl_CPM_E037]	,[hlp_CPM_E037]},
			{38, [lbl_CPM_E038]	,[hlp_CPM_E038]},
			{40, [lbl_CPM_E040]	,[hlp_CPM_E040]},
			{41, [lbl_CPM_E041]	,[hlp_CPM_E041]},
			{43, [lbl_CPM_E043]	,[hlp_CPM_E043]},
			{44, [lbl_CPM_E044]	,[hlp_CPM_E044]},
			{45, [lbl_CPM_E045]	,[hlp_CPM_E045]},
			{48, [lbl_CPM_E048]	,[hlp_CPM_E048]},
			{49, [lbl_CPM_E049]	,[hlp_CPM_E049]},
			{50, [lbl_CPM_E050]	,[hlp_CPM_E050]},
			{51, [lbl_CPM_E051]	,[hlp_CPM_E051]},
			{52, [lbl_CPM_E052]	,[hlp_CPM_E052]},
			{53, [lbl_CPM_E053]	,[hlp_CPM_E053]},
			{54, [lbl_CPM_E054]	,[hlp_CPM_E054]},
			{55, [lbl_CPM_E055]	,[hlp_CPM_E055]},
			{56, [lbl_CPM_E056]	,[hlp_CPM_E056]},
			{57, [lbl_CPM_E057]	,[hlp_CPM_E057]},
			{58, [lbl_CPM_E058]	,[hlp_CPM_E058]},
			{59, [lbl_CPM_E059]	,[hlp_CPM_E059]},
			{60, [lbl_CPM_E060]	,[hlp_CPM_E060]},
			{61, [lbl_CPM_E061]	,[hlp_CPM_E061]},
			{62, [lbl_CPM_E062]	,[hlp_CPM_E062]},
			{67, [lbl_CPM_E067]	,[hlp_CPM_E067]},
			{68, [lbl_CPM_E068]	,[hlp_CPM_E068]},
			{69, [lbl_CPM_E069]	,[hlp_CPM_E069]},
			{70, [lbl_CPM_E070]	,[hlp_CPM_E070]},
			{71, [lbl_CPM_E071]	,[hlp_CPM_E071]},
			{73, [lbl_CPM_E073]	,[hlp_CPM_E073]},
			{74, [lbl_CPM_E074]	,[hlp_CPM_E074]},
			{75, [lbl_CPM_E075]	,[hlp_CPM_E075]},
			{76, [lbl_CPM_E076]	,[hlp_CPM_E076]},
			{86, [lbl_CPM_E086]	,[hlp_CPM_E086]},
			{87, [lbl_CPM_E087]	,[hlp_CPM_E087]},
			{90, [lbl_CPM_E090]	,[hlp_CPM_E090]},
			{100, [lbl_CPM_E100],[hlp_CPM_E100]},
			{101, [lbl_CPM_E101],[hlp_CPM_E101]},
			{106, [lbl_CPM_E106],[hlp_CPM_E106]},
			{116, [lbl_CPM_E116],[hlp_CPM_E116]},
			{117, [lbl_CPM_E117],[hlp_CPM_E117]},
			{152, [lbl_CPM_E152],[hlp_CPM_E152]},
			{153, [lbl_CPM_E153],[hlp_CPM_E153]},
			{156, [lbl_CPM_E156],[hlp_CPM_E156]},
			{164, [lbl_CPM_E164],[hlp_CPM_E164]},
			{165, [lbl_CPM_E165],[hlp_CPM_E165]},
			{166, [lbl_CPM_E166],[hlp_CPM_E166]},
			{167, [lbl_CPM_E167],[hlp_CPM_E167]},
			{168, [lbl_CPM_E168],[hlp_CPM_E168]},
			{169, [lbl_CPM_E169],[hlp_CPM_E169]},
			{171, [lbl_CPM_E171],[hlp_CPM_E171]},
			{172, [lbl_CPM_E172],[hlp_CPM_E172]},
			{173, [lbl_CPM_E173],[hlp_CPM_E173]},
			{174, [lbl_CPM_E174],[hlp_CPM_E174]}
		#else
			{1, [lbl_CLM_E001],	[lbl_CLM_E001]},
			{2, [lbl_CLM_E002],	[lbl_CLM_E002]},
			{3, [lbl_CLM_E003],	[lbl_CLM_E003]},
			{4, [lbl_CLM_E004],	[lbl_CLM_E004]},
			{6, [lbl_CLM_E006],	[lbl_CLM_E006]},
			{7, [lbl_CLM_E007],	[lbl_CLM_E007]},
			{8, [lbl_CLM_E008],	[lbl_CLM_E008]},
			{9, [lbl_CLM_E009],	[lbl_CLM_E009]},
			{10, [lbl_CLM_E010],	[lbl_CLM_E010]},
			{11, [lbl_CLM_E011],	[lbl_CLM_E011]},
			{19, [lbl_CLM_E019],	[lbl_CLM_E019]},
			{25, [lbl_CLM_E025],	[lbl_CLM_E025]},
			{26, [lbl_CLM_E026],	[lbl_CLM_E026]},
			{34, [lbl_CLM_E034],	[lbl_CLM_E034]},
			{35, [lbl_CLM_E035],	[lbl_CLM_E035]},
			{36, [lbl_CLM_E036],	[lbl_CLM_E036]},
			{37, [lbl_CLM_E037],	[lbl_CLM_E037]},
			{38, [lbl_CLM_E038],	[lbl_CLM_E038]},
			{45, [lbl_CLM_E045],	[lbl_CLM_E045]},
			{46, [lbl_CLM_E046],	[lbl_CLM_E046]},
			{47, [lbl_CLM_E047],	[lbl_CLM_E047]},
			{48, [lbl_CLM_E048],	[lbl_CLM_E048]},
			{49, [lbl_CLM_E049],	[lbl_CLM_E049]},
			{53, [lbl_CLM_E053],	[lbl_CLM_E053]},
			{54, [lbl_CLM_E054],	[lbl_CLM_E054]},
			{55, [lbl_CLM_E055],	[lbl_CLM_E055]},
			{56, [lbl_CLM_E056],	[lbl_CLM_E056]},
			{57, [lbl_CLM_E057],	[lbl_CLM_E057]},
			{58, [lbl_CLM_E058],	[lbl_CLM_E058]},
			{59, [lbl_CLM_E059],	[lbl_CLM_E059]},
			{60, [lbl_CLM_E060],	[lbl_CLM_E060]},
			{61, [lbl_CLM_E061],	[lbl_CLM_E061]},
			{62, [lbl_CLM_E062],	[lbl_CLM_E062]},
			{67, [lbl_CLM_E067],	[lbl_CLM_E067]},
			{68, [lbl_CLM_E068],	[lbl_CLM_E068]},
			{69, [lbl_CLM_E069],	[lbl_CLM_E069]},
			{70, [lbl_CLM_E070],	[lbl_CLM_E070]},
			{71, [lbl_CLM_E071],	[lbl_CLM_E071]},
			{72, [lbl_CLM_E072],	[lbl_CLM_E072]},
			{73, [lbl_CLM_E073],	[lbl_CLM_E073]},
			{74, [lbl_CLM_E074],	[lbl_CLM_E074]},
			{75, [lbl_CLM_E075],	[lbl_CLM_E075]},
			{76, [lbl_CLM_E076],	[lbl_CLM_E076]},
			{77, [lbl_CLM_E077],	[lbl_CLM_E077]},
			{78, [lbl_CLM_E078],	[lbl_CLM_E078]},
			{79, [lbl_CLM_E079],	[lbl_CLM_E079]},
			{100, [lbl_CLM_E100],	[lbl_CLM_E100]},
			{101, [lbl_CLM_E101],	[lbl_CLM_E101]},
			{106, [lbl_CLM_E106],	[lbl_CLM_E106]},
			{116, [lbl_CLM_E116],	[lbl_CLM_E116]},
			{117, [lbl_CLM_E117],	[lbl_CLM_E117]},
			{152, [lbl_CLM_E152],	[lbl_CLM_E152]},
			{153, [lbl_CLM_E153],	[lbl_CLM_E153]},
			{154, [lbl_CLM_E154],	[lbl_CLM_E154]},
			{155, [lbl_CLM_E155],	[lbl_CLM_E155]},
			{156, [lbl_CLM_E156],	[lbl_CLM_E156]},
			{157, [lbl_CLM_E157],	[lbl_CLM_E157]},
			{171, [lbl_CLM_E171],	[lbl_CLM_E171]},
			{172, [lbl_CLM_E172],	[lbl_CLM_E172]},
			{173, [lbl_CLM_E173],	[lbl_CLM_E173]},
			{174, [lbl_CLM_E174],	[lbl_CLM_E174]}
		#endif

	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

phys_ehc_last_error LIKE VARIABLE phys_ehc_actual_error
{
	REDEFINE LABEL		[lbl_phys_ehc_last_error];
	REDEFINE HANDLING	READ;
}

//----------------------------------------------------------------------
//thbe
/*
VARIABLE phys_ehc_updown_support
{
	LABEL		"Up/download support";
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1); //evtl. BIT_ENUMERATED(2)
	HANDLING	READ;
}
*/


//----------------------------------------------------------------------

VARIABLE phys_device_bus_adress
{
	LABEL		[lbl_phys_device_bus_adress];
	CLASS		CONTAINED;
	TYPE		INTEGER
	{
		DEFAULT_VALUE 0;
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE phys_set_unit_to_bus
{
	LABEL		[lbl_method_Set_Unit_To_Bus];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		INTEGER;
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

VARIABLE phys_clear_last_error
{
	LABEL		[lbl_method_Clear_Last_Error];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		INTEGER;
	HANDLING	READ & WRITE;
}


//---------------------------------------------------------------------
//---------------------------------------------------------------------
//    Physical Block (PB)	read write - commands
//---------------------------------------------------------------------

COMMAND read_phys_blk
{
	BLOCK physical_block;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_blk_reserve, phys_blk_object, phys_blk_parent_class, phys_blk_class,
			phys_blk_dd_reference, phys_blk_dd_rev, phys_blk_profile, phys_blk_profile_rev,
			phys_blk_execution_time, phys_blk_num_parameters, phys_blk_index_view_1,
			phys_blk_num_view_lists
		}
	}
}

COMMAND read_phys_st_rev
{
	BLOCK physical_block;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_st_rev
		}
	}
}

COMMAND read_phys_tag_desc
{
	BLOCK physical_block;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_tag_desc
		}
	}
}

COMMAND write_phys_tag_desc
{
	BLOCK physical_block;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_strategy
{
	BLOCK physical_block;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_strategy
		}
	}
}

COMMAND write_phys_strategy
{
	BLOCK physical_block;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_alert_key
{
	BLOCK physical_block;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_alert_key
		}
	}
}

COMMAND write_phys_alert_key
{
	BLOCK physical_block;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_target_mode
{
	BLOCK physical_block;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_target_mode
		}
	}
}

COMMAND write_phys_target_mode
{
	BLOCK physical_block;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
		 	phys_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_mode
{
	BLOCK physical_block;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 phys_actual_mode, phys_permitted_mode, phys_normal_mode
		}
	}
}

COMMAND read_phys_alarm
{
	BLOCK physical_block;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_current_state_alarm_sum, phys_unacknowledged_state_alarm_sum,
			phys_unreported_state_alarm_sum, phys_disabled_state_alarm_sum
		}
	}
}

COMMAND read_phys_software_rev
{
	BLOCK physical_block;
	INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_software_rev
		}
	}
}

COMMAND read_phys_hardware_rev
{
	BLOCK physical_block;
	INDEX 9;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_hardware_rev
		}
	}
}

COMMAND read_phys_device_man_id
{
	BLOCK physical_block;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_man_id
		}
	}
}

COMMAND read_phys_device_id
{
	BLOCK physical_block;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_id
		}
	}
}

COMMAND read_phys_device_ser_num
{
	BLOCK physical_block;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_ser_num
		}
	}
}

COMMAND read_phys_diagnosis
{
	BLOCK physical_block;
	INDEX 13;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_diagnosis
		}
	}
}

COMMAND read_phys_diagnosis_extension
{
	BLOCK physical_block;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_diagnosis_ext_BYTE_1,
			phys_diagnosis_ext_BYTE_2,
			phys_diagnosis_ext_BYTE_3,
			phys_diagnosis_ext_BYTE_4,
			phys_diagnosis_ext_BYTE_5,
			phys_diagnosis_ext_BYTE_6
		}
	}
}

COMMAND read_phys_device_certification
{
	BLOCK physical_block;
	INDEX 17;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_certification
		}
	}
}

COMMAND read_phys_write_locking
{
	BLOCK physical_block;
	INDEX 18;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_write_locking
		}
	}
}

COMMAND write_phys_write_locking
{
	BLOCK physical_block;
	INDEX 18;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_write_locking
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_factory_reset
{
	BLOCK physical_block;
	INDEX 19;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_factory_reset
		}
	}
}

COMMAND write_phys_factory_reset
{
	BLOCK physical_block;
	INDEX 19;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_factory_reset
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_descriptor
{
	BLOCK physical_block;
	INDEX 20;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_descriptor
		}
	}
}

COMMAND write_phys_descriptor
{
	BLOCK physical_block;
	INDEX 20;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_descriptor
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_message
{
	BLOCK physical_block;
	INDEX 21;
	OPERATION  READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_message
		}
	}
}

COMMAND write_phys_message
{
	BLOCK physical_block;
	INDEX 21;
	OPERATION  WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_message
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_install_date
{
	BLOCK physical_block;
	INDEX 22;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_install_date
		}
	}
}

COMMAND read_phys_local_op_enable
{
	BLOCK physical_block;
	INDEX 23;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_local_op_enable
		}
	}
}

COMMAND write_phys_local_op_enable
{
	BLOCK physical_block;
	INDEX 23;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_local_op_enable
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_ident_number
{
	BLOCK physical_block;
	INDEX 24;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_ident_number
		}
	}
}

COMMAND write_phys_ident_number
{
	BLOCK physical_block;
	INDEX 24;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_ident_number
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_HW_write_protection
{
	BLOCK physical_block;
	INDEX 25;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_HW_write_protection
		}
	}
}

COMMAND read_phys_device_configuration
{
	BLOCK physical_block;
	INDEX 36;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_configuration
		}
	}
}

COMMAND read_phys_init_state
{
	BLOCK physical_block;
	INDEX 37;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_init_state
		}
	}
}

COMMAND write_phys_init_state
{
	BLOCK physical_block;
	INDEX 37;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_init_state
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_device_state
{
	BLOCK physical_block;
	INDEX 38;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_state
		}
	}
}

COMMAND write_phys_device_state
{
	BLOCK physical_block;
	INDEX 38;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_device_state
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_global_status
{
	BLOCK physical_block;
	INDEX 39;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_global_status
		}
	}
}

//---------------------------------------------------------------------
//    Physical Block: Manufacturer specific parameters
//---------------------------------------------------------------------

COMMAND read_phys_ehc_actual_error
{
	BLOCK physical_block;
	INDEX 48;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_ehc_actual_error
		}
	}
}

COMMAND read_phys_ehc_last_error
{
	BLOCK physical_block;
	INDEX 49;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_ehc_last_error
		}
	}
}

//thbe
/*
COMMAND read_phys_ehc_updown_support
{
	BLOCK physical_block;
	INDEX 50;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_ehc_updown_support
		}
	}
}
*/

COMMAND read_phys_device_bus_adress
{
	BLOCK physical_block;
	INDEX 53;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_device_bus_adress
		}
	}
}

COMMAND read_phys_set_unit_to_bus
{
	BLOCK physical_block;
	INDEX 54;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_set_unit_to_bus
		}
	}
}

COMMAND write_phys_set_unit_to_bus
{
	BLOCK physical_block;
	INDEX 54;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_set_unit_to_bus
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_clear_last_error
{
	BLOCK physical_block;
	INDEX 55;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_clear_last_error
		}
	}
}

COMMAND write_phys_clear_last_error
{
	BLOCK physical_block;
	INDEX 55;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			phys_clear_last_error
		}
		REPLY
		{
		}
	}
}

REFRESH Refresh_phys_st_rev
{
	phys_tag_desc,
	phys_strategy,
	phys_alert_key,
	phys_target_mode,
	phys_factory_reset,
	phys_descriptor,
	phys_message,
	phys_install_date,
	phys_ident_number,
	phys_init_state:
		phys_st_rev
}

