/************************************************************/
/****					Observe menu					*****/
/************************************************************/
MENU DTM_observe_menu
{
	ACCESS ONLINE;
	LABEL "Observe";
	ITEMS
	{
		Page_display_out_CH1,		
		Page_display_out_CH2,
		Page_display_out_controller
	}
}


MENU Page_display_out_CH1
{
	CW_access_for_onlinemenus
	LABEL	"Channel 1|de|Kanal 1";
	ITEMS
	{
		manufact_MeasValue_CH1	(READ_ONLY),
		manufact_Temp_CH1		(READ_ONLY)
	}
}


MENU Page_display_out_CH2
{
  LABEL	"Channel 2|de|Kanal 2";
  ITEMS {
    manufact_MeasValue_CH2	(READ_ONLY),
    manufact_Temp_CH2		(READ_ONLY)
  }
}

MENU Page_display_out_controller
{
	LABEL	[lbl_manufact_Controller];
	ITEMS
	{
		manufact_Contr_Set_Value
	}
}


/************************************************************/
/****					Trend menu						*****/
/************************************************************/
MENU DTM_trend_menu
{
	ACCESS ONLINE;
	LABEL "Trend";
	ITEMS
	{
		manufact_MeasValue_CH1,
		manufact_Temp_CH1,
		manufact_MeasValue_CH2,
		manufact_Temp_CH2,
	}
}


/************************************************************/
/****					Lock/unlock menu				*****/
/************************************************************/
MENU DTM_lock_menu
{
	ACCESS ONLINE;
	LABEL "Lock/Unlock";
	ITEMS
	{
			phys_write_locking
	}
}

/************************************************************/
/****					reset menu						*****/
/************************************************************/
MENU DTM_reset_menu
{
	ACCESS ONLINE;
	LABEL "Reset";
	ITEMS
	{
		#ifndef _PDM_
			manufact_Reset,
		#endif
		phys_factory_reset
	}
}

/************************************************************/
/****					Simulation menu					*****/
/************************************************************/
MENU DTM_simulation_menu
{
	LABEL "Simulation";
	ACCESS ONLINE;
	ITEMS
	{	
		Page_Simulation_ai1,
		Page_Simulation_ai2,
		Page_Simulation_ai3,
		Page_Simulation_ai4
	}
}

MENU Page_Simulation_ai1
{
	CW_access_for_onlinemenus
	LABEL	"Analog input 1";
	ITEMS
	{
		analog_input1_simulation_enabled,
		analog_input1_simulate_status_quality,
		analog_input1_simulate_status_limit,
		analog_input1_simulate_value
	}
}

MENU Page_Simulation_ai2
{
	CW_access_for_onlinemenus
	LABEL	"Analog input 2";
	ITEMS
	{
		analog_input2_simulation_enabled,
		analog_input2_simulate_status_quality,
		analog_input2_simulate_status_limit,
		analog_input2_simulate_value
	}
}

MENU Page_Simulation_ai3
{
	CW_access_for_onlinemenus
	LABEL	"Analog input 3";
	ITEMS
	{
		analog_input3_simulation_enabled,
		analog_input3_simulate_status_quality,
		analog_input3_simulate_status_limit,
		analog_input3_simulate_value
	}
}

MENU Page_Simulation_ai4
{
	CW_access_for_onlinemenus
	LABEL	"Analog input 4";
	ITEMS
	{
		analog_input4_simulation_enabled,
		analog_input4_simulate_status_quality,
		analog_input4_simulate_status_limit,
		analog_input4_simulate_value
	}
}


/************************************************************/
/****					Diagnosis menu					*****/
/************************************************************/
MENU DTM_diagnosis_menu
{
	LABEL "Diagnosis";
	ACCESS ONLINE;
	ITEMS
	{
		Menu_S_limitStates,
		Page_TransducerBlocks,
		Page_FunctionBlocks,
	}
}

MENU Menu_S_limitStates
{
	CW_access_for_onlinemenus
	LABEL	"Limit states|de|Grenzwertzustnde";
	ITEMS
	{
		ON_S_limitState_ai1,
		ON_S_limitState_ai2,
		ON_S_limitState_ai3,
		ON_S_limitState_ai4
  }
}


MENU ON_S_limitState_ai1
{
	CW_access_for_onlinemenus
	LABEL	"Limit states AI1|de|Grenwertstatus AI1";
	ITEMS
	{
		Page_diagnosis_function1_block_hi_hi,
		Page_diagnosis_function1_block_hi,
		Page_diagnosis_function1_block_lo,
		Page_diagnosis_function1_block_lo_lo
	}
}

MENU ON_S_limitState_ai2
{
	CW_access_for_onlinemenus
	LABEL	"Limit states AI2|de|Grenzwertstatus AI2";
	ITEMS
	{
		Page_diagnosis_function2_block_hi_hi,
		Page_diagnosis_function2_block_hi,
		Page_diagnosis_function2_block_lo,
		Page_diagnosis_function2_block_lo_lo
	}
}

MENU ON_S_limitState_ai3
{
	CW_access_for_onlinemenus
	LABEL	"Limit states AI3|de|Grenzwertstatus AI3";
	ITEMS
	{
		Page_diagnosis_function3_block_hi_hi,
		Page_diagnosis_function3_block_hi,
		Page_diagnosis_function3_block_lo,
		Page_diagnosis_function3_block_lo_lo
	}
}

MENU ON_S_limitState_ai4
{
	CW_access_for_onlinemenus
	LABEL	"Limit states AI4|de|Grenzwertstatus AI4";
	ITEMS
	{
		Page_diagnosis_function4_block_hi_hi,
		Page_diagnosis_function4_block_hi,
		Page_diagnosis_function4_block_lo,
		Page_diagnosis_function4_block_lo_lo
	}
}

MENU Page_TransducerBlocks
{
	CW_access_for_onlinemenus
	LABEL	"Transducer blocks";
	ITEMS
	{
		Page_TransducerBlock1,
		Page_TransducerBlock2,
		Page_TransducerBlock3,
		Page_TransducerBlock4
	}
}


MENU Page_TransducerBlock1
{
	CW_access_for_onlinemenus
	LABEL	"Transducer block 1";
	ITEMS
	{
		trans1_pv_meas_value,
		trans1_pv_meas_status_quality,
		trans1_pv_meas_status_limits,
		trans1_pv_meas_date
	}
}

MENU Page_TransducerBlock2
{
	CW_access_for_onlinemenus
	LABEL	"Transducer block 2";
	ITEMS
	{
		trans2_pv_meas_value,
		trans2_pv_meas_status_quality,
		trans2_pv_meas_status_limits,
		trans2_pv_meas_date
	}
}

MENU Page_TransducerBlock3
{
	CW_access_for_onlinemenus
	LABEL	"Transducer block 3";
	ITEMS
	{
		trans3_pv_meas_value,
		trans3_pv_meas_status_quality,
		trans3_pv_meas_status_limits,
		trans3_pv_meas_date
	}
}

MENU Page_TransducerBlock4
{
	CW_access_for_onlinemenus
	LABEL	"Transducer block 4";
	ITEMS
	{
		trans4_pv_meas_value,
		trans4_pv_meas_status_quality,
		trans4_pv_meas_status_limits,
		trans4_pv_meas_date
	}
}



MENU Page_FunctionBlocks
{
	CW_access_for_onlinemenus
	LABEL	"Function blocks";
	ITEMS
	{
		Page_FunctionBlock1,
		Page_FunctionBlock2,
		Page_FunctionBlock3,
		Page_FunctionBlock4
	}
}

MENU Page_FunctionBlock1
{
	CW_access_for_onlinemenus
	LABEL	"Analog input block 1";
	ITEMS
	{
		analog_input1_out_value,
		analog_input1_out_status_quality,
		analog_input1_out_status_limit
	}
}

MENU Page_FunctionBlock2
{
	CW_access_for_onlinemenus
	LABEL	"Analog input block 2";
	ITEMS
	{
		analog_input2_out_value,
		analog_input2_out_status_quality,
		analog_input2_out_status_limit
	}
}

MENU Page_FunctionBlock3
{
	CW_access_for_onlinemenus
	LABEL	"Analog input block 3";
	ITEMS
	{
		analog_input3_out_value,
		analog_input3_out_status_quality,
		analog_input3_out_status_limit
	}
}

MENU Page_FunctionBlock4
{
	CW_access_for_onlinemenus
	LABEL	"Analog input block 4";
	ITEMS
	{
		analog_input4_out_value,
		analog_input4_out_status_quality,
		analog_input4_out_status_limit
	}
}