//**********************************************************************
//    Transducer Block	1 (Main Process Value)	
//**********************************************************************

BLOCK function_TRANSDUCER_BLOCK_1
{
	TYPE TRANSDUCER;
	NUMBER 1;
}

//----------------------------------------------------------------------
//  BLOCK_OBJECT: 12 x trans1_blk...
//----------------------------------------------------------------------

trans1_blk_reserve		LIKE VARIABLE	phys_blk_reserve
{											
}											

trans1_blk_object		LIKE VARIABLE	phys_blk_object
{
	REDEFINE TYPE ENUMERATED (1)
	{
		{	1,	[blk_block_object_TRANSDUCER]	}
	}
}		
									
trans1_blk_parent_class		LIKE VARIABLE	phys_blk_parent_class
{	
	REDEFINE TYPE ENUMERATED(1)
	{
		DEFAULT_VALUE 7;
		{	7,	[trans_blk_parent_class_ANALYSIS]	}
	}
}	
										
trans1_blk_class		LIKE VARIABLE	phys_blk_class
{											
}	
										
trans1_blk_dd_reference		LIKE VARIABLE	phys_blk_dd_reference
{											
}	
										
trans1_blk_dd_rev		LIKE VARIABLE	phys_blk_dd_rev
{											
}	
										
trans1_blk_profile		LIKE VARIABLE	phys_blk_profile
{											
}	
										
trans1_blk_profile_rev		LIKE VARIABLE	phys_blk_profile_rev
{											
}	
										
trans1_blk_execution_time		LIKE VARIABLE	phys_blk_execution_time
{											
}		
									
trans1_blk_num_parameters		LIKE VARIABLE	phys_blk_num_parameters
{											
}		
									
trans1_blk_index_view_1		LIKE VARIABLE	phys_blk_index_view_1
{											
}		
									
trans1_blk_num_view_lists		LIKE VARIABLE	phys_blk_num_view_lists
{											
}											

trans1_st_rev		LIKE VARIABLE	phys_st_rev
{											
}											

trans1_tag_desc		LIKE VARIABLE	phys_tag_desc
{											
}											

trans1_strategy		LIKE VARIABLE	phys_strategy
{											
}											

trans1_alert_key		LIKE VARIABLE	phys_alert_key
{											
}											

trans1_target_mode		LIKE VARIABLE	phys_target_mode
{											
}											

trans1_actual_mode		LIKE VARIABLE	phys_actual_mode
{											
}											

trans1_permitted_mode		LIKE VARIABLE	phys_permitted_mode
{											
}											

trans1_normal_mode		LIKE VARIABLE	phys_normal_mode
{											
}											

trans1_current_state_alarm_sum		LIKE VARIABLE	phys_current_state_alarm_sum
{											
}											

trans1_unacknowledged_state_alarm_sum		LIKE VARIABLE	phys_unacknowledged_state_alarm_sum
{											
}											

trans1_unreported_state_alarm_sum		LIKE VARIABLE	phys_unreported_state_alarm_sum
{											
}											

trans1_disabled_state_alarm_sum		LIKE VARIABLE	phys_disabled_state_alarm_sum
{											
}											

//----------------------------------------------------------------------

VARIABLE trans1_component_name
{
	LABEL		[lbl_trans1_component_name];		
	CLASS		CONTAINED;
	TYPE		ASCII (32)
	{
		DEFAULT_VALUE	"";
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------

VARIABLE trans1_pv_meas_value
{
	LABEL		[lbl_trans1_pv_meas_value];		
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DISPLAY_FORMAT_TRANS1_PV
	}
	HANDLING	READ;
}

VARIABLE trans1_pv_meas_status_quality
{
	LABEL		[lbl_trans1_pv_meas_status_quality];		
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x20;
		STATUS_OUTPUT_NO_RCAS
	}
	HANDLING	READ;
}

VARIABLE trans1_pv_meas_status_limits
{
	LABEL		[lbl_trans1_pv_meas_status_limits];		
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE 0;
		STATUS_OUTPUT_LIMIT
	}
	HANDLING	READ;
}

VARIABLE trans1_pv_meas_date
{
	LABEL		[lbl_trans1_pv_meas_date];		
	CLASS		CONTAINED & DYNAMIC;
	TYPE		DATE_AND_TIME;
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE trans1_pv_unit
{
	LABEL		[trans_analysis_unit];
	HELP		[trans_analysis_unit_help];
	CLASS		CONTAINED; //#tb & DYNAMIC;
	TYPE		ENUMERATED (2)
	{
		DEF_TRANS_UNIT_DEFAULT
		DEF_TRANS_UNIT
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE trans1_pv_unit_text
{
	LABEL		[lbl_trans1_pv_unit_text];
	CLASS		CONTAINED; //#tb & DYNAMIC;
	TYPE		ASCII (8)
	{
		#ifdef DEVICE_PARAM_PH
			DEFAULT_VALUE "pH";
		#else
			DEFAULT_VALUE "mS/cm";
		#endif
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE trans1_active_range
{
	LABEL		[lbl_trans1_active_range];		
	CLASS		CONTAINED;
	TYPE	ENUMERATED (1)
	{
		DEFAULT_VALUE	1;
		{	1,	[lbl_trans1_active_range_1]	}
	}
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE trans1_auto_range_on
{
	LABEL		[lbl_trans1_auto_range_on];		
	CLASS		CONTAINED;
	TYPE	ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[OFF]	},
		{	1,	[ON]	}
	}
	HANDLING	READ; //thbe & WRITE;
}

//----------------------------------------------------------------------

VARIABLE trans1_sampling_rate
{
	LABEL		[lbl_trans1_sampling_rate];		
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4)
	{
		DEFAULT_VALUE	500;
	}
	HANDLING	READ; //thbe & WRITE;
}

//----------------------------------------------------------------------

VARIABLE trans1_number_of_ranges
{
	LABEL		[lbl_trans1_number_of_ranges];		
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER;
	HANDLING	READ;
}

//----------------------------------------------------------------------

VARIABLE trans1_range_begin
{
	LABEL		[lbl_trans1_range_begin];		
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		#ifdef DEVICE_PARAM_PH
			DEFAULT_VALUE	-2;
		#else
			DEFAULT_VALUE	0;
		#endif
	}
	HANDLING	READ;//#tb & WRITE; //different as decribed in manual
}

VARIABLE trans1_range_end
{
	LABEL		[lbl_trans1_range_end];		
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		#ifdef DEVICE_PARAM_PH
			DEFAULT_VALUE	16;
		#else
			DEFAULT_VALUE	2000;
		#endif
	}
	HANDLING	READ;//#tb & WRITE; //different as decribed in manual
}

//----------------------------------------------------------------------



//---------------------------------------------------------------------
//    Transducer Block 1 (TB1)	read write - commands
//---------------------------------------------------------------------

COMMAND read_trans1_blk
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_blk_reserve, trans1_blk_object, trans1_blk_parent_class, trans1_blk_class,
			trans1_blk_dd_reference, trans1_blk_dd_rev, trans1_blk_profile, trans1_blk_profile_rev,
			trans1_blk_execution_time, trans1_blk_num_parameters, trans1_blk_index_view_1,
			trans1_blk_num_view_lists
		}
	}
}

COMMAND read_trans1_st_rev
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_st_rev
		}
	}
}

COMMAND read_trans1_tag_desc
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tag_desc
		}
	}
}

COMMAND write_trans1_tag_desc
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_strategy
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_strategy
		}
	}
}

COMMAND write_trans1_strategy
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_alert_key
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_alert_key
		}
	}
}

COMMAND write_trans1_alert_key
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_target_mode
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_target_mode
		}
	}
}

COMMAND write_trans1_target_mode
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
		 	trans1_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_mode
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 trans1_actual_mode, trans1_permitted_mode, trans1_normal_mode
		}
	}
}

COMMAND read_trans1_alarm
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_current_state_alarm_sum, trans1_unacknowledged_state_alarm_sum,
			trans1_unreported_state_alarm_sum, trans1_disabled_state_alarm_sum
		}
	}
}

COMMAND read_trans1_component_name
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_component_name
		}
	}
}

COMMAND write_trans1_component_name
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 8;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
		 	trans1_component_name
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_pv_meas
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 9;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_pv_meas_value, 
			trans1_pv_meas_status_quality	<0xFC>, 
			trans1_pv_meas_status_limits	<0x03>, 
			trans1_pv_meas_date
		}
	}
}

COMMAND read_trans1_pv_unit
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_pv_unit
		}
	}
}

COMMAND read_trans1_pv_unit_text
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_pv_unit_text
		}
	}
}

COMMAND read_trans1_active_range
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_active_range
		}
	}
}


COMMAND read_trans1_auto_range_on
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 13;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_auto_range_on
		}
	}
}

COMMAND read_trans1_sampling_rate
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_sampling_rate
		}
	}
}

COMMAND write_trans1_sampling_rate
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 14;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_sampling_rate
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_number_of_ranges
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 25;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_number_of_ranges
		}
	}
}

COMMAND read_trans1_range
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 26;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_range_begin, trans1_range_end
		}
	}
}

COMMAND write_trans1_range
{
	BLOCK function_TRANSDUCER_BLOCK_1;
	INDEX 26;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_range_begin, trans1_range_end
		}
		REPLY
		{
		}
	}
}

REFRESH Refresh_trans1_st_rev
{
	trans1_tag_desc,
	trans1_strategy,
	trans1_alert_key,
	trans1_target_mode,
	trans1_component_name:
		trans1_st_rev
}

