//**********************************************************************
//    Transducer Block	2 (Main Process Value)	
//**********************************************************************

BLOCK function_TRANSDUCER_BLOCK_2
{
	TYPE TRANSDUCER;
	NUMBER 2;
}

//----------------------------------------------------------------------
//  BLOCK_OBJECT: 12 x trans2_blk...
//----------------------------------------------------------------------

trans2_blk_reserve		LIKE VARIABLE	phys_blk_reserve
{											
}											

trans2_blk_object		LIKE VARIABLE	trans1_blk_object
{											
}		
									
trans2_blk_parent_class		LIKE VARIABLE	trans1_blk_parent_class
{											
}	
										
trans2_blk_class		LIKE VARIABLE	phys_blk_class
{											
}	
										
trans2_blk_dd_reference		LIKE VARIABLE	phys_blk_dd_reference
{											
}	
										
trans2_blk_dd_rev		LIKE VARIABLE	phys_blk_dd_rev
{											
}	
										
trans2_blk_profile		LIKE VARIABLE	phys_blk_profile
{											
}	
										
trans2_blk_profile_rev		LIKE VARIABLE	phys_blk_profile_rev
{											
}	
										
trans2_blk_execution_time		LIKE VARIABLE	phys_blk_execution_time
{											
}		
									
trans2_blk_num_parameters		LIKE VARIABLE	phys_blk_num_parameters
{											
}		
									
trans2_blk_index_view_1		LIKE VARIABLE	phys_blk_index_view_1
{											
}		
									
trans2_blk_num_view_lists		LIKE VARIABLE	phys_blk_num_view_lists
{											
}											

trans2_st_rev		LIKE VARIABLE	phys_st_rev
{											
}											

trans2_tag_desc		LIKE VARIABLE	phys_tag_desc
{											
}											

trans2_strategy		LIKE VARIABLE	phys_strategy
{											
}											

trans2_alert_key		LIKE VARIABLE	phys_alert_key
{											
}											

trans2_target_mode		LIKE VARIABLE	phys_target_mode
{											
}											

trans2_actual_mode		LIKE VARIABLE	phys_actual_mode
{											
}											

trans2_permitted_mode		LIKE VARIABLE	phys_permitted_mode
{											
}											

trans2_normal_mode		LIKE VARIABLE	phys_normal_mode
{											
}											

trans2_current_state_alarm_sum		LIKE VARIABLE	phys_current_state_alarm_sum
{											
}											

trans2_unacknowledged_state_alarm_sum		LIKE VARIABLE	phys_unacknowledged_state_alarm_sum
{											
}											

trans2_unreported_state_alarm_sum		LIKE VARIABLE	phys_unreported_state_alarm_sum
{											
}											

trans2_disabled_state_alarm_sum		LIKE VARIABLE	phys_disabled_state_alarm_sum
{											
}											

//----------------------------------------------------------------------

VARIABLE trans2_component_name
{
	LABEL		[lbl_trans1_component_name];		
	CLASS		CONTAINED;
	TYPE		ASCII (32)
	{
		DEFAULT_VALUE	"";
	}
	HANDLING	READ & WRITE;
}

//----------------------------------------------------------------------
/*
VARIABLE trans2_pv_meas_value
{
	LABEL		[lbl_trans1_pv_meas_value];		
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DISPLAY_FORMAT_TRANS2_PV
	}
	HANDLING	READ;
}
*/
trans2_pv_meas_value LIKE VARIABLE trans1_pv_meas_value
{
	REDEFINE TYPE FLOAT
	{
		DISPLAY_FORMAT_TRANS2_PV
	}
}

/*
VARIABLE trans2_pv_meas_status_quality
{
	LABEL		[lbl_trans1_pv_meas_status_quality];		
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0x20;
		STATUS_OUTPUT_NO_RCAS
	}
	HANDLING	READ;
}
*/
trans2_pv_meas_status_quality LIKE VARIABLE trans1_pv_meas_status_quality
{}

/*
VARIABLE trans2_pv_meas_status_limits
{
	LABEL		[lbl_trans1_pv_meas_status_limits];		
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE 0;
		STATUS_OUTPUT_LIMIT
	}
	HANDLING	READ;
}
*/
trans2_pv_meas_status_limits LIKE VARIABLE trans1_pv_meas_status_limits
{}

/*
VARIABLE trans2_pv_meas_date
{
	LABEL		[lbl_trans1_pv_meas_date];		
	CLASS		CONTAINED & DYNAMIC;
	TYPE		DATE_AND_TIME;
	HANDLING	READ;
}
*/
trans2_pv_meas_date LIKE VARIABLE trans1_pv_meas_date
{}

//----------------------------------------------------------------------
/*
VARIABLE trans2_pv_unit
{
	LABEL		[trans_analysis_unit];
	HELP		[trans_analysis_unit_help];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (2)
	{
		{ UNIT_degC, [unit_1001]	},	//thbe
		{ UNIT_degF, [unit_1002]	}	//thbe
	}
	HANDLING	READ;
}
*/
trans2_pv_unit LIKE VARIABLE trans1_pv_unit
{
	REDEFINE TYPE ENUMERATED(2)
	{
		DEFAULT_VALUE 1001;
		{ UNIT_degC, [unit_1001]	},	//thbe
		{ UNIT_degF, [unit_1002]	}	//thbe
	}
}

//----------------------------------------------------------------------
/*
VARIABLE trans2_pv_unit_text
{
	LABEL		[lbl_trans1_pv_unit_text];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ASCII (8);
	HANDLING	READ;
}
*/
trans2_pv_unit_text LIKE VARIABLE trans1_pv_unit_text
{
	REDEFINE TYPE		ASCII (8)
	{
		DEFAULT_VALUE "C";
	}

}

//----------------------------------------------------------------------

/*
VARIABLE trans2_active_range
{
	LABEL		[lbl_trans1_active_range];		
	CLASS		CONTAINED;
	TYPE	ENUMERATED (1)
	{
		DEFAULT_VALUE	1;
		{	1,	[lbl_trans1_active_range_1]	}
	}
	HANDLING	READ;
}
*/
trans2_active_range LIKE VARIABLE trans1_active_range
{}


//----------------------------------------------------------------------
/*
VARIABLE trans2_auto_range_on
{
	LABEL		[lbl_trans1_auto_range_on];		
	CLASS		CONTAINED;
	TYPE	ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{	0,	[OFF]	},
		{	1,	[ON]	}
	}
	HANDLING	READ;
}
*/
trans2_auto_range_on LIKE VARIABLE trans1_auto_range_on
{}

//----------------------------------------------------------------------
/*
VARIABLE trans2_sampling_rate
{
	LABEL		[lbl_trans1_sampling_rate];		
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (4);
	HANDLING	READ;
}
*/
trans2_sampling_rate LIKE VARIABLE trans1_sampling_rate
{}

//----------------------------------------------------------------------
/*
VARIABLE trans2_number_of_ranges
{
	LABEL		[lbl_trans1_number_of_ranges];		
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER;
	HANDLING	READ;
}
*/
trans2_number_of_ranges LIKE VARIABLE trans1_number_of_ranges
{}

//----------------------------------------------------------------------
/*
VARIABLE trans2_range_begin
{
	LABEL		[lbl_trans1_range_begin];		
	CLASS		CONTAINED;
	TYPE		FLOAT;
	HANDLING	READ;
}
*/
trans2_range_begin LIKE VARIABLE trans1_range_begin
{
	REDEFINE TYPE FLOAT
	{
		DEFAULT_VALUE	-50;
	}
}

/*
VARIABLE trans2_range_end
{
	LABEL		[lbl_trans1_range_end];		
	CLASS		CONTAINED;
	TYPE		FLOAT;
	HANDLING	READ;
}
*/
trans2_range_end LIKE VARIABLE trans1_range_end
{
	REDEFINE TYPE FLOAT
	{
		DEFAULT_VALUE	150;
	}
}

//----------------------------------------------------------------------



//---------------------------------------------------------------------
//    Transducer Block 1 (TB1)	read write - commands
//---------------------------------------------------------------------

COMMAND read_trans2_blk
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 0;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_blk_reserve, trans2_blk_object, trans2_blk_parent_class, trans2_blk_class,
			trans2_blk_dd_reference, trans2_blk_dd_rev, trans2_blk_profile, trans2_blk_profile_rev,
			trans2_blk_execution_time, trans2_blk_num_parameters, trans2_blk_index_view_1,
			trans2_blk_num_view_lists
		}
	}
}

COMMAND read_trans2_st_rev
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 1;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_st_rev
		}
	}
}

COMMAND read_trans2_tag_desc
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_tag_desc
		}
	}
}

COMMAND write_trans2_tag_desc
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 2;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_tag_desc
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_strategy
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 3;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_strategy
		}
	}
}

COMMAND write_trans2_strategy
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 3;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_strategy
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_alert_key
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 4;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_alert_key
		}
	}
}

COMMAND write_trans2_alert_key
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 4;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_alert_key
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_target_mode
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 5;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_target_mode
		}
	}
}

COMMAND write_trans2_target_mode
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 5;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
		 	trans2_target_mode
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_mode
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 6;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			 trans2_actual_mode, trans2_permitted_mode, trans2_normal_mode
		}
	}
}

COMMAND read_trans2_alarm
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 7;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_current_state_alarm_sum, trans2_unacknowledged_state_alarm_sum,
			trans2_unreported_state_alarm_sum, trans2_disabled_state_alarm_sum
		}
	}
}

COMMAND read_trans2_component_name
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 8;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_component_name
		}
	}
}

COMMAND write_trans2_component_name
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 8;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
		 	trans2_component_name
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans2_pv_meas
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 9;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_pv_meas_value, 
			trans2_pv_meas_status_quality	<0xFC>, 
			trans2_pv_meas_status_limits	<0x03>, 
			trans2_pv_meas_date
		}
	}
}

COMMAND read_trans2_pv_unit
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 10;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_pv_unit
		}
	}
}

COMMAND read_trans2_pv_unit_text
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 11;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_pv_unit_text
		}
	}
}

COMMAND read_trans2_active_range
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 12;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_active_range
		}
	}
}

COMMAND read_trans2_auto_range_on
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 13;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_auto_range_on
		}
	}
}


COMMAND read_trans2_sampling_rate
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 14;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_sampling_rate
		}
	}
}

COMMAND read_trans2_number_of_ranges
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 25;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_number_of_ranges
		}
	}
}

COMMAND read_trans2_range
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 26;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans2_range_begin, trans2_range_end
		}
	}
}

COMMAND write_trans2_range
{
	BLOCK function_TRANSDUCER_BLOCK_2;
	INDEX 26;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans2_range_begin, trans2_range_end
		}
		REPLY
		{
		}
	}
}

REFRESH Refresh_trans2_st_rev
{
	trans2_tag_desc,
	trans2_strategy,
	trans2_alert_key,
	trans2_target_mode,
	trans2_component_name:
		trans2_st_rev
}

