//******************************************************************************
//****	V0 - Matrix
//******************************************************************************
VARIABLE manufact_MeasValue_CH1
{
	LABEL		[lbl_manufact_MeasValue_CH1];	
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	7.0; 
		DISPLAY_FORMAT	"4.2f";
	}
	HANDLING	READ;
}

VARIABLE manufact_Temp_CH1
{
	LABEL		[lbl_manufact_Temp_CH1];	
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	25.0; 
		DISPLAY_FORMAT	"4.1f";
	}
	HANDLING	READ;
}

VARIABLE manufact_Hold_State
{
	LABEL		[lbl_manufact_Hold_State];
	CLASS		CONTAINED & DYNAMIC;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{ 0, [off]	},
		{ 1, [on]	}
	}
	HANDLING	READ;
}

VARIABLE manufact_Damping_MeasVal
{
	LABEL		[lbl_manufact_Damping_MeasVal];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	1;
		MIN_VALUE		1;
		MAX_VALUE		30;
	}
	CONSTANT_UNIT	[sec];
	HANDLING	READ & WRITE;
}

VARIABLE manufact_Unit_CH1
{
	LABEL		[lbl_manufact_Unit_CH1];
	//#tb CLASS		CONTAINED;
	CLASS		CONTAINED&DYNAMIC;

	TYPE		ENUMERATED (1)
	{
		DEF_UNITS_DEVICE
	}
	HANDLING	READ;
}

VARIABLE manufact_MeasValue_CH2
{
	LABEL		[lbl_manufact_MeasValue_CH2];	
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	7.0; 
		DISPLAY_FORMAT	"4.2f";
	}
	HANDLING	READ;
}


VARIABLE manufact_Temp_CH2
{
	LABEL		[lbl_manufact_Temp_CH2];	
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	25.0; 
		DISPLAY_FORMAT	"4.1f";
	}
	HANDLING	READ;
}

VARIABLE manufact_Damping_Temp
{
	LABEL		[lbl_manufact_Damping_Temp];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER (1)
	{
		DEFAULT_VALUE	1;
		MIN_VALUE		1;
		MAX_VALUE		30;
	}
	CONSTANT_UNIT	[sec];
	HANDLING	READ & WRITE;
}

VARIABLE manufact_Unit_CH2
{
	LABEL		[lbl_manufact_Unit_CH2];
	//#tb CLASS		CONTAINED;
	CLASS		CONTAINED&DYNAMIC;

	TYPE		ENUMERATED (1)
	{
		DEF_UNITS_DEVICE
	}
	HANDLING	READ;
}

VARIABLE manufact_Unit_Temp
{
	LABEL		[lbl_manufact_Unit_Temp];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEF_TEMP_UNITS
	}
	HANDLING	READ;
}

COMMAND read_manufact_MeasValue_CH1
{
	SLOT	5;
	INDEX 100;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_MeasValue_CH1
		}
	}
}

COMMAND read_manufact_Temp_CH1
{
	SLOT	5;
	INDEX 101;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Temp_CH1
		}
	}
}

COMMAND read_manufact_Hold_State
{
	SLOT	5;
	INDEX 102;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Hold_State
		}
	}
}

COMMAND read_manufact_Damping_MeasVal
{
	SLOT	5;
	INDEX 103;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Damping_MeasVal
		}
	}
}

COMMAND write_manufact_Damping_MeasVal
{
	SLOT	5;
	INDEX 103;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			manufact_Damping_MeasVal
		}
		REPLY
		{
		}
	}
}

COMMAND read_manufact_Unit_CH1
{
	SLOT	5;
	INDEX 104;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Unit_CH1
		}
	}
}

COMMAND read_manufact_MeasValue_CH2
{
	SLOT	5;
	INDEX 105;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_MeasValue_CH2
		}
	}
}

COMMAND read_manufact_Temp_CH2
{
	SLOT	5;
	INDEX 106;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Temp_CH2
		}
	}
}

COMMAND read_manufact_Damping_Temp
{
	SLOT	5;
	INDEX 107;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Damping_Temp
		}
	}
}

COMMAND write_manufact_Damping_Temp
{
	SLOT	5;
	INDEX 107;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			manufact_Damping_Temp
		}
		REPLY
		{
		}
	}
}

COMMAND read_manufact_Unit_CH2
{
	SLOT	5;
	INDEX 108;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Unit_CH2
		}
	}
}

COMMAND read_manufact_Unit_Temp
{
	SLOT	5;
	INDEX 109;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Unit_Temp
		}
	}
}

//******************************************************************************
//****	Unit relations     *****************************************************
//******************************************************************************

UNIT UNITREL_manufact_Unit_CH1
{
	manufact_Unit_CH1:
		manufact_MeasValue_CH1,
		manufact_Sensor_Lower_Limit,
		manufact_Sensor_Upper_Limit
}

UNIT UNITREL_manufact_Unit_CH2
{
	manufact_Unit_CH2:
		manufact_MeasValue_CH2
}

UNIT UNITREL_manufact_Unit_Temp
{
	manufact_Unit_Temp:
		manufact_Temp_CH1,
		manufact_Temp_CH2
}
