
//******************************************************************************
//****	V3 - Matrix
//******************************************************************************

VARIABLE manufact_Zeropoint_CH1
{
	LABEL		[lbl_manufact_Zeropoint_CH1];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0; 
		DISPLAY_FORMAT	"4.0f";
	}
	HANDLING	READ;
}

VARIABLE manufact_Slope_CH1
{
	LABEL		[lbl_manufact_Slope_CH1];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	59.16; 
		DISPLAY_FORMAT	"4.2f";
	}
	CONSTANT_UNIT	"mV/pH";
	HANDLING	READ;
}

VARIABLE manufact_Unit_Zeropoint_CH1
{
	LABEL		[lbl_manufact_Unit_Zeropoint_CH1];
	CLASS		CONTAINED;

	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	36;
		{ 59, "pH"	},
		{ 36, "mV"	}
	}
	HANDLING	READ;
}

VARIABLE manufact_Time_CH1
{
	LABEL		[lbl_manufact_Time_CH1];
	CLASS		CONTAINED;
	TYPE		ASCII (5)
	{
		DEFAULT_VALUE    "xx:xx";
	}
	HANDLING	READ;
}

VARIABLE manufact_Date_CH1
{
	LABEL		[lbl_manufact_Date_CH1];
	CLASS		CONTAINED;
	TYPE		ASCII (8)
	{
		DEFAULT_VALUE    "xx.xx.xx";
	}
	HANDLING	READ;
}

VARIABLE manufact_Zeropoint_CH2
{
	LABEL		[lbl_manufact_Zeropoint_CH2];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0; 
		DISPLAY_FORMAT	"4.0f";
	}
	HANDLING	READ;
}

VARIABLE manufact_Slope_CH2
{
	LABEL		[lbl_manufact_Slope_CH2];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	59.16; 
		DISPLAY_FORMAT	"4.2f";
	}
	CONSTANT_UNIT	"mV/pH";
	HANDLING	READ;
}

VARIABLE manufact_Unit_Zeropoint_CH2
{
	LABEL		[lbl_manufact_Unit_Zeropoint_CH2];
	CLASS		CONTAINED;

	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	36;
		{ 59, "pH"	},
		{ 36, "mV"	}
	}
	HANDLING	READ;
}

VARIABLE manufact_Time_CH2
{
	LABEL		[lbl_manufact_Time_CH2];
	CLASS		CONTAINED;
	TYPE		ASCII (5)
	{
		DEFAULT_VALUE    "xx:xx";
	}
	HANDLING	READ;
}

VARIABLE manufact_Date_CH2
{
	LABEL		[lbl_manufact_Date_CH2];
	CLASS		CONTAINED;
	TYPE		ASCII (8)
	{
		DEFAULT_VALUE    "xx.xx.xx";
	}
	HANDLING	READ;
}

VARIABLE manufact_Cell_Const_CH1
{
	LABEL		[lbl_manufact_Cell_Const_CH1];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.1; 
		DISPLAY_FORMAT	"6.4f";
	}
	CONSTANT_UNIT	"cm-1";
	HANDLING	READ;
}

VARIABLE manufact_Adaption_Factor_CH1
{
	LABEL		[lbl_manufact_Adaption_Factor_CH1];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0; 
		DISPLAY_FORMAT	"6.2f";
	}
	HANDLING	READ;
	VALIDITY
		IF (manufact_Sensor_Type == DEVICE_LF_IND) { TRUE;}
		ELSE { FALSE;}
}

VARIABLE manufact_Air_Set_CH1
{
	LABEL		[lbl_manufact_Air_Set_CH1];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0; 
		DISPLAY_FORMAT	"6.2f";
	}
	HANDLING	READ;
	CONSTANT_UNIT	"S/cm";
	VALIDITY
		IF (manufact_Sensor_Type == DEVICE_LF_IND) { TRUE;}
		ELSE { FALSE;}
}

VARIABLE manufact_Cell_Const_CH2
{
	LABEL		[lbl_manufact_Cell_Const_CH2];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.1; 
		DISPLAY_FORMAT	"6.4f";
	}
	CONSTANT_UNIT	"cm-1";
	HANDLING	READ;
}

VARIABLE manufact_Adaption_Factor_CH2
{
	LABEL		[lbl_manufact_Adaption_Factor_CH2];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0; 
		DISPLAY_FORMAT	"6.2f";
	}
	HANDLING	READ;
	VALIDITY
		IF (manufact_Sensor_Type == DEVICE_LF_IND) { TRUE;}
		ELSE { FALSE;}
}
VARIABLE manufact_Air_Set_CH2
{
	LABEL		[lbl_manufact_Air_Set_CH2];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0; 
		DISPLAY_FORMAT	"6.2f";
	}
	HANDLING	READ;
	CONSTANT_UNIT	"S/cm";
	VALIDITY
		IF (manufact_Sensor_Type == DEVICE_LF_IND) { TRUE;}
		ELSE { FALSE;}
}


COMMAND read_manufact_Zeropoint_CH1
{
	SLOT	5;
	INDEX 114;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Zeropoint_CH1
		}
	}
}
COMMAND read_manufact_Slope_CH1
{
	SLOT	5;
	INDEX 115;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Slope_CH1
		}
	}
}
COMMAND read_manufact_Unit_Zeropoint_CH1
{
	SLOT	5;
	INDEX 164;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Unit_Zeropoint_CH1
		}
	}
}
COMMAND read_manufact_Time_CH1
{
	SLOT	5;
	INDEX 116;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Time_CH1
		}
	}
}
COMMAND read_manufact_Date_CH1
{
	SLOT	5;
	INDEX 117;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Date_CH1
		}
	}
}
COMMAND read_manufact_Zeropoint_CH2
{
	SLOT	5;
	INDEX 118;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Zeropoint_CH2
		}
	}
}
COMMAND read_manufact_Slope_CH2
{
	SLOT	5;
	INDEX 119;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Slope_CH2
		}
	}
}


COMMAND read_manufact_Unit_Zeropoint_CH2
{
	SLOT	5;
	INDEX 165;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Unit_Zeropoint_CH2
		}
	}
}

COMMAND read_manufact_Time_CH2
{
	SLOT	5;
	INDEX INDEX_manufact_Time_CH2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Time_CH2
		}
	}
}
COMMAND read_manufact_Date_CH2
{
	SLOT	5;
	INDEX INDEX_manufact_Date_CH2;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Date_CH2
		}
	}
}
COMMAND read_manufact_Cell_Const_CH1
{
	SLOT	5;
	INDEX 113;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Cell_Const_CH1
		}
	}
}
COMMAND read_manufact_Adaption_Factor_CH1
{
	SLOT	5;
	INDEX 114;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Adaption_Factor_CH1
		}
	}
}
COMMAND read_manufact_Air_Set_CH1
{
	SLOT	5;
	INDEX 115;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Air_Set_CH1
		}
	}
}
COMMAND read_manufact_Cell_Const_CH2
{
	SLOT	5;
	INDEX 118;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Cell_Const_CH2
		}
	}
}
COMMAND read_manufact_Adaption_Factor_CH2
{
	SLOT	5;
	INDEX 119;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Adaption_Factor_CH2
		}
	}
}
COMMAND read_manufact_Air_Set_CH2
{
	SLOT	5;
	INDEX 120;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Air_Set_CH2
		}
	}
}
