
//******************************************************************************
//****	V6 - Matrix
//******************************************************************************

VARIABLE manufact_Controller
{
	LABEL		[lbl_manufact_Controller];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{ 0, [off]	},
		{ 1, [on]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE manufact_Contr_Setpoint
{
	LABEL		[lbl_manufact_Contr_Setpoint];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		#ifdef DEVICE_PARAM_PH
			DEFAULT_VALUE	7.0; 
		#else
			DEFAULT_VALUE	1000.0;
		#endif
		DISPLAY_FORMAT	"4.2f";
	}
	HANDLING	READ & WRITE;
}

VARIABLE manufact_Contr_Set_Value
{
	LABEL		[lbl_manufact_Contr_Set_Value];
	CLASS		CONTAINED & DYNAMIC;
	CONSTANT_UNIT	"%";
	TYPE		UNSIGNED_INTEGER (2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING	READ;
}

VARIABLE manufact_Contr_Unit_Setpoint
{
	LABEL		[lbl_manufact_Contr_Unit_Setpoint];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEF_UNITS_DEVICE
	}
	HANDLING	READ;
}

VARIABLE manufact_LS1_unit
{
	LABEL		[lbl_manufact_LS1_unit];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEF_UNITS_DEVICE
	}
	HANDLING	READ;
}

VARIABLE manufact_LS2_unit
{
	LABEL		[lbl_manufact_LS1_unit];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEF_UNITS_DEVICE
	}
	HANDLING	READ;
}

VARIABLE manufact_LS3_unit
{
	LABEL		[lbl_manufact_LS1_unit];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEF_UNITS_DEVICE
	}
	HANDLING	READ;
}

VARIABLE manufact_LS4_unit
{
	LABEL		[lbl_manufact_LS1_unit];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEF_UNITS_DEVICE
	}
	HANDLING	READ;
}

VARIABLE manufact_LS5_unit
{
	LABEL		[lbl_manufact_LS1_unit];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEF_UNITS_DEVICE
	}
	HANDLING	READ;
}

COMMAND read_manufact_Controller
{
	SLOT	5;
	INDEX INDEX_manufact_Controller;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Controller
		}
	}
}

COMMAND write_manufact_Controller
{
	SLOT	5;
	INDEX INDEX_manufact_Controller;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			manufact_Controller
		}
		REPLY
		{
		}
	}
}

COMMAND read_manufact_Contr_Setpoint
{
	SLOT	5;
	INDEX INDEX_manufact_Contr_Setpoint;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Contr_Setpoint
		}
	}
}

COMMAND write_manufact_Contr_Setpoint
{
	SLOT	5;
	INDEX INDEX_manufact_Contr_Setpoint;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			manufact_Contr_Setpoint
		}
		REPLY
		{
		}
	}
}

COMMAND read_manufact_Contr_Set_Value
{
	SLOT	5;
	INDEX INDEX_manufact_Contr_Set_Value;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Contr_Set_Value
		}
	}
}

COMMAND read_manufact_Contr_Unit_Setpoint
{
	SLOT	5;
	INDEX INDEX_manufact_Contr_Unit_Setpoint;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Contr_Unit_Setpoint
		}
	}
}

COMMAND read_manufact_LS1_unit
{
	SLOT	5;
	INDEX INDEX_manufact_LS1_unit;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_LS1_unit
		}
	}
}

COMMAND read_manufact_LS2_unit
{
	SLOT	5;
	INDEX INDEX_manufact_LS2_unit;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_LS2_unit
		}
	}
}

COMMAND read_manufact_LS3_unit
{
	SLOT	5;
	INDEX INDEX_manufact_LS3_unit;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_LS3_unit
		}
	}
}

COMMAND read_manufact_LS4_unit
{
	SLOT	5;
	INDEX INDEX_manufact_LS4_unit;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_LS4_unit
		}
	}
}

COMMAND read_manufact_LS5_unit
{
	SLOT	5;
	INDEX INDEX_manufact_LS5_unit;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_LS5_unit
		}
	}
}

//******************************************************************************
//****	Unit relations     *****************************************************
//******************************************************************************

UNIT UNITREL_manufact_Contr_Unit_Setpoint
{
	manufact_Contr_Unit_Setpoint:
	manufact_Contr_Setpoint
}
