
//******************************************************************************
//****	V9 - Matrix
//******************************************************************************

VARIABLE manufact_Sensor_Serial_No
{
	LABEL		[lbl_manufact_Sensor_Serial_No];
	CLASS		CONTAINED;

	#ifdef _PDM_
		TYPE		UNSIGNED_INTEGER (4)
		{
			DEFAULT_VALUE	0;
		}
	#else
		TYPE		UNSIGNED_INTEGER (4)
		{
			DEFAULT_VALUE	12345678;
		}
	#endif
	
	HANDLING	READ;
}

VARIABLE manufact_Sensor_Lower_Limit
{
	LABEL		[lbl_manufact_Sensor_Lower_Limit];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0; 
	}
	HANDLING	READ;
}

VARIABLE manufact_Sensor_Upper_Limit
{
	LABEL		[lbl_manufact_Sensor_Upper_Limit];	
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		#ifdef DEVICE_PARAM_PH
			DEFAULT_VALUE	16; 
		#else
			DEFAULT_VALUE	2000; 
		#endif
	}
	HANDLING	READ;
}

VARIABLE manufact_Sensor_Type
{
	LABEL		[lbl_manufact_Sensor_Type];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	DEFAULT_SENSOR_TYPE;
		{ DEVICE_LF_IND,  [lbl_manufact_Sensor_Type_ind]	},
		{ DEVICE_LF_COND, [lbl_manufact_Sensor_Type_cond]}
	}
	HANDLING	READ;
}

//---------------------------------------------------------------------------------
// read + write commands
//---------------------------------------------------------------------------------

COMMAND read_manufact_Sensor_Serial_No
{
	SLOT	5;
	INDEX INDEX_manufact_Sensor_Serial_No;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Sensor_Serial_No
		}
	}
}
COMMAND read_manufact_Sensor_Lower_Limit
{
	SLOT	5;
	INDEX INDEX_manufact_Sensor_Lower_Limit;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Sensor_Lower_Limit
		}
	}
}

COMMAND read_manufact_Sensor_Upper_Limit
{
	SLOT	5;
	INDEX INDEX_manufact_Sensor_Upper_Limit;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Sensor_Upper_Limit
		}
	}
}

COMMAND read_manufact_Sensor_Type
{
	SLOT	5;
	INDEX 163;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			manufact_Sensor_Type
		}
	}
}
