/*************************************************************************/
/* Set unit to bus implementation                                        */
/*  input macros:                                                        */
/*   - __DDC__set_unit_to_bus_BLOCK_INDEX (should be declared)           */
/*   - __DDC__set_unit_to_bus_offline_method                             */
/*   - __DDC__set_unit_to_bus_online_method                              */
/*************************************************************************/

#ifdef __DDC__set_unit_to_bus_BLOCK_INDEX

VARIABLE phys_pa_set_unit_to_bus {
	CLASS CONTAINED;
	TYPE ENUMERATED {
		{ 0, "0" }
		{ 1, "1" }
	}
	HANDLING READ & WRITE;
}

COMMAND read_phys_pa_set_unit_to_bus {
	__DDC__set_unit_to_bus_BLOCK_INDEX
	OPERATION READ;
	TRANSACTION {
		REQUEST {
		}
		REPLY {
			phys_pa_set_unit_to_bus
		}
	}
}

COMMAND write_phys_pa_set_unit_to_bus {
	__DDC__set_unit_to_bus_BLOCK_INDEX
	OPERATION WRITE;
	TRANSACTION {
		REQUEST {
			phys_pa_set_unit_to_bus
		}
		REPLY {
		}
	}
}

METHOD set_unit_to_bus_offline_post_edit {
	LABEL [phys_pa_set_unit_to_bus];
	DEFINITION {
		__DDC__set_unit_to_bus_offline_method
#ifdef  __DDC__set_unit_to_bus_offline_method_manufacturer
        if (ivar_value(phys_ident_number) == 1)
        {
		__DDC__set_unit_to_bus_offline_method_manufacturer
        }
#endif
		save_values();
	}
}

VARIABLE phys_pa_set_unit_to_bus_offline {
	LABEL [phys_pa_set_unit_to_bus];
	HELP [phys_pa_set_unit_to_bus_help];
	CLASS LOCAL;
	TYPE ENUMERATED {
		{ 1, "confirm|de|Besttigen" }
	}
#ifdef phys_pa_set_unit_to_bus_offline_HANDLING
	HANDLING phys_pa_set_unit_to_bus_offline_HANDLING
#else
	HANDLING READ & WRITE;
#endif
	POST_EDIT_ACTIONS {
		set_unit_to_bus_offline_post_edit
	}
}

METHOD set_unit_to_bus_online_post_edit {
	LABEL [phys_pa_set_unit_to_bus];
	DEFINITION {
		iassign(phys_pa_set_unit_to_bus, 1);
		WriteCommand(write_phys_pa_set_unit_to_bus);
		save_values();
		__DDC__set_unit_to_bus_online_method
	}
}

VARIABLE phys_pa_set_unit_to_bus_online {
	LABEL [phys_pa_set_unit_to_bus];
	HELP [phys_pa_set_unit_to_bus_help];
	CLASS LOCAL;
	TYPE ENUMERATED {
		{ 1, "confirm|de|Besttigen" }
	}
#ifdef phys_pa_set_unit_to_bus_online_HANDLING
	HANDLING phys_pa_set_unit_to_bus_online_HANDLING
#else
	HANDLING READ & WRITE;
#endif
	POST_EDIT_ACTIONS {
		set_unit_to_bus_online_post_edit
	}
}

#endif
